unit DynTextEdit;

interface

uses Windows, StdCtrls, Types, Forms, Classes, Controls,
  ObjectList;

type
  TDynTextEdit = class(TEdit)
  private
    FElementBox: TElementBox;
    FPosition: TPoint;
    procedure MyKeyPress(Sender: TObject; var Key: Char);
    procedure MyExit(Sender: TObject);
  public
    constructor Create(AElementBox: TElementBox; APosition, ARelative: TPoint; ACaption: string; AOwner: TComponent); reintroduce;
    destructor Destroy; override;
  end;

implementation

uses Haupt;

procedure TDynTextEdit.MyKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
  begin
    key := #0;
    gTextCaption := Text;
    FElementBox.AddTextModule(FPosition, gTextCaption, gTextSize, gColor);
    Form1.Simulation.Paint;
    Free;
  end else if key = #27 then
    begin
      key := #0;
      Free;
    end;
end;

procedure TDynTextEdit.MyExit(Sender: TObject);
begin
  Free;
end;

constructor TDynTextEdit.Create(AElementBox: TElementBox; APosition, ARelative: TPoint; ACaption: string; AOwner: TComponent);
begin
  inherited Create(AOwner);
  FElementBox := AElementBox;
  FPosition := APosition;

  Parent := AOwner as TWinControl;
  Height := gTextSize + 8;
  Top := APosition.Y * gDistance - gTextSize div 2 - 3 - ARelative.Y;
  Left := APosition.X * gDistance + 8 - ARelative.X;
  Width := Parent.Width - Left - 10;
  BorderStyle := bsNone;
  Font.Color := gColor;
  Font.Size := gTextSize;
  Text := ACaption;

  OnKeyPress := MyKeyPress;
  OnExit := MyExit;

  SetFocus;
end;

destructor TDynTextEdit.Destroy;
begin
  gTextCaption := Text;
  inherited Destroy;
end;

end.
