(*
Haupt.pas
Copyright (C) 2006  Christian Brugger <brugger.christian(AT)web.de>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version. This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
details. You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA 02110, USA
*)
unit Haupt;

interface

uses
  Windows, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ExtCtrls,
  ComCtrls, Menus, ActnList, ObjectList, DynDockPanel, XPMan, IniFiles, ImgList,
  ToolWin, StdCtrls, Messages;

const ProgramName = 'LogikSim';
const ProgramVersion = '0.6.4';
const FileHeader = 'LogikSim Christian';

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Datei1: TMenuItem;
    ffnen1: TMenuItem;
    Speichern1: TMenuItem;
    Neu1: TMenuItem;
    N4: TMenuItem;
    ActionList1: TActionList;
    aAddLine: TAction;
    aAddLineConnector: TAction;
    aAddAnd: TAction;
    aAddOr: TAction;
    aAddXor: TAction;
    aAddSwitch: TAction;
    aAddLed: TAction;
    aNone: TAction;
    aPowerOn: TAction;
    aRemove: TAction;
    aNew: TAction;
    Bauteile1: TMenuItem;
    Und1: TMenuItem;
    Oder1: TMenuItem;
    Xor1: TMenuItem;
    N1: TMenuItem;
    Schalter1: TMenuItem;
    Led1: TMenuItem;
    N2: TMenuItem;
    Beenden1: TMenuItem;
    aExit: TAction;
    Leitungen1: TMenuItem;
    ziehen1: TMenuItem;
    verbinden1: TMenuItem;
    aOpen: TAction;
    aSave: TAction;
    Bearbeiten1: TMenuItem;
    Lschen1: TMenuItem;
    Pos1: TMenuItem;
    N3: TMenuItem;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    aSaveAs: TAction;
    Speichernunter1: TMenuItem;
    btnNew: TToolButton;
    btnOpen: TToolButton;
    btnSave: TToolButton;
    btnSaveAs: TToolButton;
    ToolButton5: TToolButton;
    ToolButton8: TToolButton;
    btnOption: TToolButton;
    aOptions: TAction;
    N5: TMenuItem;
    Optionen1: TMenuItem;
    aAbout: TAction;
    Hilfe1: TMenuItem;
    About1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Lini: TMenuItem;
    N6: TMenuItem;
    Und2: TMenuItem;
    Oder2: TMenuItem;
    Xor2: TMenuItem;
    N7: TMenuItem;
    Schalter2: TMenuItem;
    Led2: TMenuItem;
    N8: TMenuItem;
    Lschen2: TMenuItem;
    ToolButton2: TToolButton;
    StatusBar1: TStatusBar;
    ToolBar2: TToolBar;
    btnLine: TToolButton;
    btnAnd: TToolButton;
    btnOr: TToolButton;
    btnXor: TToolButton;
    btnLed: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    btnSwitch: TToolButton;
    ToolButton3: TToolButton;
    ImageList2: TImageList;
    aSetNegationPoint: TAction;
    N9: TMenuItem;
    Negationspunkt1: TMenuItem;
    ToolButton4: TToolButton;
    btnPowerOn: TToolButton;
    aRePaint: TAction;
    Neuzeichnen1: TMenuItem;
    N10: TMenuItem;
    Import: TMenuItem;
    Konvert: TMenuItem;
    OpenDialogLWS: TOpenDialog;
    aIC: TAction;
    aAddInverter: TAction;
    Inverter1: TMenuItem;
    N11: TMenuItem;
    aAddFlipFlop: TAction;
    FlipFlop1: TMenuItem;
    aAddCouplingDiode: TAction;
    Leitungenkoppeln1: TMenuItem;
    N12: TMenuItem;
    aAddDecoderNoClock: TAction;
    Decod1: TMenuItem;
    aAddDecoderClock: TAction;
    DecodermitTakteingang1: TMenuItem;
    aAddHalfAdder: TAction;
    aAddFullAdder: TAction;
    Halbaddierer1: TMenuItem;
    Volladdierer1: TMenuItem;
    btnCouplingDiode: TToolButton;
    btnInverter: TToolButton;
    ToolButton11: TToolButton;
    btnHalfAdder: TToolButton;
    btnFullAdder: TToolButton;
    btnFlipFlop: TToolButton;
    btnDecoderNoClock: TToolButton;
    btnRemove: TToolButton;
    ToolButton10: TToolButton;
    aAddShiftingRegister: TAction;
    Schieberegister1: TMenuItem;
    btnShiftingRegister: TToolButton;
    tLoad: TTimer;
    aAddClockGenerator: TAction;
    Leitungenkoppeln2: TMenuItem;
    btnClockGenerator: TToolButton;
    btnDecoderClock: TToolButton;
    aShowOptionsGeneral: TAction;
    aShowOptionsClockGenerator: TAction;
    aShowOptionsStandardModules: TAction;
    Fenster1: TMenuItem;
    About2: TMenuItem;
    Standardbauteile1: TMenuItem;
    aktgeber1: TMenuItem;
    PageControl2: TPageControl;
    aIncreaseInputConnector: TAction;
    aDecreaseInputConnector: TAction;
    N13: TMenuItem;
    Inverter2: TMenuItem;
    Halbaddierer2: TMenuItem;
    Volladdierer2: TMenuItem;
    FlipFlop2: TMenuItem;
    Decoder1: TMenuItem;
    DecodermitTakteingang2: TMenuItem;
    Schieberegister2: TMenuItem;
    aktgeber2: TMenuItem;
    Leitungenkoppeln3: TMenuItem;
    aAddText: TAction;
    btnText: TToolButton;
    aAddDelayModule: TAction;
    Verzgerungsglied1: TMenuItem;
    ext1: TMenuItem;
    About3: TMenuItem;
    btnDelayModule: TToolButton;
    Verzgerungsglied2: TMenuItem;
    procedure KonvertClick(Sender: TObject);
    procedure ImportClick(Sender: TObject);
    procedure aRePaintExecute(Sender: TObject);
    procedure aSetNegationPointExecute(Sender: TObject);
    procedure aAboutExecute(Sender: TObject);
    procedure aOptionsExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure aSaveAsExecute(Sender: TObject);
    procedure aSaveExecute(Sender: TObject);
    procedure aOpenExecute(Sender: TObject);
    procedure aRemoveExecute(Sender: TObject);
    procedure aPowerOnExecute(Sender: TObject);
    procedure aAddLineConnectorExecute(Sender: TObject);
    procedure aAddLedExecute(Sender: TObject);
    procedure aAddSwitchExecute(Sender: TObject);
    procedure aAddXorExecute(Sender: TObject);
    procedure aAddOrExecute(Sender: TObject);
    procedure aAddAndExecute(Sender: TObject);
    procedure aAddLineExecute(Sender: TObject);
    procedure aExitExecute(Sender: TObject);
    procedure aNewExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure aAddInverterExecute(Sender: TObject);
    procedure aAddFlipFlopExecute(Sender: TObject);
    procedure aAddCouplingDiodeExecute(Sender: TObject);
    procedure aAddDecoderNoClockExecute(Sender: TObject);
    procedure aAddDecoderClockExecute(Sender: TObject);
    procedure aAddHalfAdderExecute(Sender: TObject);
    procedure aAddFullAdderExecute(Sender: TObject);
    procedure aAddShiftingRegisterExecute(Sender: TObject);
    procedure tLoadTimer(Sender: TObject);
    procedure aAddClockGeneratorExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure aShowOptionsGeneralExecute(Sender: TObject);
    procedure aShowOptionsStandardModulesExecute(Sender: TObject);
    procedure aShowOptionsClockGeneratorExecute(Sender: TObject);
    procedure aIncreaseInputConnectorExecute(Sender: TObject);
    procedure aDecreaseInputConnectorExecute(Sender: TObject);
    procedure aAddTextExecute(Sender: TObject);
    procedure aAddDelayModuleExecute(Sender: TObject);
  private
    FDatei: string;
    FSimulation: TSimulation;
    paInfoLeft, paInfoRight: TDynDockPanel;
    function RemoveExtension(AFileName: string): string;
    procedure SetDatei(ADatei: string);
    property Datei: string read FDatei write SetDatei;
    procedure UnCheckAllButtons;
    procedure SetEditActions(AStatus: boolean);
    procedure NewSimulation(Sender: TObject);
    procedure ApplicationEventsMessage(var Msg: tagMSG; var Handled: Boolean);
  public
    property Simulation: TSimulation read FSimulation write FSimulation;
    procedure SetAction(AAction: TActAction; ASender: TObject);
    procedure RefreshForms;
    procedure SaveToIniFile(AFileName: string);
    procedure LoadFromIniFile(AFileName: string);
    procedure GlobalSave;
    procedure GlobalLoad;
  end;

var
  Form1: TForm1;
  IsPowerOn: boolean;
  IsLWS: boolean;
  

implementation

{$R *.dfm}
{$R sim1.RES}

uses About, LWSImport, Options, OptionsGeneral, OptionsStandardModules,
  OptionsClockGenerator, DockableForm;

var ActAction, TmpAction: TActAction;
    First: boolean;

procedure TForm1.SaveToIniFile(AFileName: String);
  procedure DockableFormSaveToStream(ADockableForm: TDockableForm; AStream: TStream);
  var ALeft, ATop: integer;
    ANameIndex: byte;
  begin
    with ADockableForm do
      if Floating and Visible then
      begin
        ANameIndex := NameIndex;
        ALeft := Left;
        ATop := Top;
        AStream.Write(ANameIndex, SizeOf(ANameIndex));
        AStream.Write(ALeft, SizeOf(ALeft));
        AStream.Write(ATop, SizeOf(ATop));
      end;
  end;

var MemStream: TMemoryStream;
  IniFile: TIniFile;
begin
  MemStream := TMemoryStream.Create;
  IniFile := TIniFile.Create(AFileName);
  try
                                                // MainForm
    IniFile.WriteBool('Interface', 'Maximized', WindowState = wsMaximized);
    IniFile.WriteInteger('Interface', 'Left', Left);
    IniFile.WriteInteger('Interface', 'Top', Top);
    IniFile.WriteInteger('Interface', 'Width', Width);
    IniFile.WriteInteger('Interface', 'Height', Height);

    paInfoLeft.SaveToStream(MemStream);         // paInfoLeft
    MemStream.Position := 0;
    IniFile.WriteBinaryStream('Interface', 'paInfoLeft', MemStream);

    MemStream.Clear;

    paInfoRight.SaveToStream(MemStream);        // paInfoRight
    MemStream.Position := 0;
    IniFile.WriteBinaryStream('Interface', 'paInfoRight', MemStream);

    MemStream.Clear;                                 
                                                // None
    DockableFormSaveToStream(FormOptionsGeneral, MemStream);
    DockableFormSaveToStream(FormOptionsStandardModules, MemStream);
    DockableFormSaveToStream(FormOptionsClockGenerator, MemStream);
    MemStream.Position := 0;
    IniFile.WriteBinaryStream('Interface', 'None', MemStream);
  finally
    IniFile.Free;
    MemStream.Free;
  end;
end;

procedure TForm1.LoadFromIniFile(AFileName: string);
var MemStream: TMemoryStream;
  IniFile: TIniFile;
  N: integer;

  procedure NoneLoadFromStream(AStream: TStream);
  var ALeft, ATop: integer;
    ANameIndex: byte;
    ADockableForm: TDockableForm;
  begin
    AStream.Position := 0;
    while AStream.Position + SizeOf(ANameIndex) + SizeOf(ALeft) + SizeOf(ATop) <= AStream.Size do
    begin
      AStream.Read(ANameIndex, SizeOf(ANameIndex));
      AStream.Read(ALeft, SizeOf(ALeft));
      AStream.Read(ATop, SizeOf(ATop));
      case ANameIndex of
        0: ADockableForm := FormOptionsGeneral;
        1: ADockableForm := FormOptionsStandardModules;
        2: ADockableForm := FormOptionsClockGenerator;
        else ADockableForm := Nil;
      end;
      if ADockableForm <> Nil then
        with ADockableForm do
        begin
          Top := ATop;
          Left := ALeft;
        end;
    end;
  end;
  
begin
  FormOptionsGeneral.Close;
  FormOptionsStandardModules.Close;
  FormOptionsClockGenerator.Close;
  MemStream := TMemoryStream.Create;
  IniFile := TIniFile.Create(AFileName);
  try                                               // MainForm                                                      
    if IniFile.ReadBool('Interface', 'Maximized', true) then
      WindowState := wsMaximized
    else WindowState := wsNormal;
    Left := IniFile.ReadInteger('Interface', 'Left', 0);
    Top := IniFile.ReadInteger('Interface', 'Top', 0);
    Width := IniFile.ReadInteger('Interface', 'Width', 1024);
    Height := IniFile.ReadInteger('Interface', 'Height', 768);
    
                                                    // paInfoLeft
    N := IniFile.ReadBinaryStream('Interface', 'paInfoLeft', MemStream);
    if N > 0 then
      paInfoLeft.LoadFromStream(MemStream);

    MemStream.Clear;
                                                    //  paInfoRight
    N := IniFile.ReadBinaryStream('Interface', 'paInfoRight', MemStream);
    if N > 0 then
      paInfoRight.LoadFromStream(MemStream);

    MemStream.Clear;
                                                    // None
    N := IniFile.ReadBinaryStream('Interface', 'None', MemStream);
    if N > 0 then
      NoneLoadFromStream(MemStream);
  finally
    IniFile.Free;
    MemStream.Free;
  end;
end;

function TForm1.RemoveExtension(AFileName: string): string;
var I: integer;
  Found: boolean;
begin
  I := Length(AFileName);
  Found := false;
  while not Found and (I > 0) do
  begin
    Found := AFileName[I] = '.';
    dec(I);
  end;
  if Found then
    Result := copy(AFileName, 1, I)
  else Result := AFileName;
end;

procedure TForm1.SetDatei(ADatei: string);
var Tmp: string;

  function GetFileName(ADatei: string): string;
  var I: integer;
      Found: boolean;
  begin
    Result := '';
    IsLWS := false;
    Found := false;
    I := length(ADatei) - 1;
    while not Found and (I > -1) do
    begin
      if ADatei[I] = '\' then
      begin
        Found := true;
        Result := copy(ADatei, I + 1, length(Adatei) - I);
      end;
      dec(I);
    end;
  end;

begin
  FDatei := ADatei;
  if ADatei = '' then
    Tmp := 'Unbenannt'
  else Tmp := GetFileName(ADatei);
  Caption :=  ProgramName + ' ' + ProgramVersion + ' - ' + Tmp;
end;

procedure TForm1.GlobalSave;
var s: string;
begin
  s := FormMainOptions.GetRightConfigPath;
  if s <> '' then
  try
    SaveToIniFile(s);
    FormMainOptions.SaveSettingsToFile(s);
    FormOptionsGeneral.SaveSettingsToFile(s);
    FormOptionsStandardModules.SaveSettingsToFile(s);
  except
    showmessage('Fehler beim Schreiben der Config');
  end;
end;

procedure TForm1.GlobalLoad;
var s: string;
begin
  s := FormMainOptions.GetRightConfigPath;
  if s <> '' then
  begin
    try
      FormMainOptions.LoadSettingsFromFile(s);
      LoadFromIniFile(s);
      FormOptionsGeneral.LoadSettingsFromFile(s);
      FormOptionsStandardModules.LoadSettingsFromFile(s);

      // check forms
  		with FormOptionsStandardModules do
				if FormMainOptions.cbStandardModulesView.Checked then
					if Visible and Haupt.IsPowerOn then
						Hide
					else
				else if Tag = 1 then // if hidden
						Show;
			with FormOptionsClockGenerator do
				if FormMainOptions.cbClockGeneratorView.Checked then
					if Visible and not (Haupt.IsPowerOn and Form1.Simulation.ClockGeneratorExists) then
						Hide
					else
				else if Tag = 1 then // if hidden
						Show;
    except
      showmessage('Fehler beim Lesen der Config');
    end;
  end else begin                                     // default!
    WindowState := wsMaximized;
    FormOptionsGeneral.Show;
    FormOptionsStandardModules.Show;
    FormOptionsClockGenerator.Show;
  end;
end;

procedure TForm1.UnCheckAllButtons;
begin
  btnRemove.Down := false;
  btnLine.Down := false;
  btnCouplingDiode.Down := false;
  btnAnd.Down := false;
  btnOr.Down := false;
  btnXor.Down := false;
  btnInverter.Down := false;
  btnDelayModule.Down := false;
  btnHalfAdder.Down := false;
  btnFullAdder.Down := false;
  btnFlipFlop.Down := false;
  btnDecoderNoClock.Down := false;
  btnDecoderClock.Down := false;
  btnShiftingRegister.Down := false;
  btnClockGenerator.Down := false;
  btnSwitch.Down := false;
  btnLed.Down := false;
  btnText.Down := false;

  FormOptionsStandardModules.btnAnd.Down := false;
  FormOptionsStandardModules.btnOr.Down := false;
  FormOptionsStandardModules.btnXor.Down := false;
  FormOptionsStandardModules.btnLed.Down := false;
  FormOptionsStandardModules.btnText.Down := false;
  FormOptionsStandardModules.InterfaceTextSize(false);
end;

procedure TForm1.SetEditActions(AStatus: Boolean);
begin
  AAddLine.Enabled := AStatus;
  AAddLineConnector.Enabled := AStatus;
  AAddCouplingDiode.Enabled := AStatus;
  AAddAnd.Enabled := AStatus;
  AAddOr.Enabled := AStatus;
  AAddXor.Enabled := AStatus;
  AAddSwitch.Enabled := AStatus;
  AAddLed.Enabled := AStatus;
  AAddText.Enabled := AStatus;
  AAddInverter.Enabled := AStatus;
  AAddDelayModule.Enabled := AStatus;
  AAddHalfAdder.Enabled := AStatus;
  AAddFullAdder.Enabled := AStatus;
  AAddFlipFlop.Enabled := AStatus;
  AAddDecoderNoClock.Enabled := AStatus;
  AAddDecoderClock.Enabled := AStatus;
  AAddShiftingRegister.Enabled := AStatus;
  if aAddClockGenerator.Tag = 0 then
    aAddClockGenerator.Enabled := AStatus
  else aAddClockGenerator.Enabled := false;
  ASetNegationPoint.Enabled := AStatus;
  ARemove.Enabled := AStatus;

  FormOptionsStandardModules.btnAnd.Enabled := AStatus;
  FormOptionsStandardModules.btnOr.Enabled := AStatus;
  FormOptionsStandardModules.btnXor.Enabled := AStatus;
  FormOptionsStandardModules.btnLed.Enabled := AStatus;
end;

procedure TForm1.SetAction(AAction: TActAction; ASender: TObject);
begin
  case AAction of
    AddLine: AAddLineExecute(ASender);
    AddLineConnector: AAddLineConnectorExecute(ASender);
    AddCouplingDiode: AAddCouplingDiodeExecute(ASender);
    AddAnd: AAddAndExecute(ASender);
    AddOr: AAddOrExecute(ASender);
    AddXor: AAddXorExecute(ASender);
    AddSwitch: AAddSwitchExecute(ASender);
    AddLed: AAddLedExecute(ASender);
    AddText: AAddTextExecute(ASender);
    AddInverter: AAddInverterExecute(ASender);
    AddDelayModule: AAddDelayModuleExecute(ASender);
    AddHalfAdder: AAddHalfAdderExecute(ASender);
    AddFullAdder: AAddFullAdderExecute(ASender);
    AddFlipFlop: AAddFlipFlopExecute(ASender);
    AddDecoderNoClock: AAddDecoderNoClockExecute(ASender);
    AddDecoderClock: AAddDecoderClockExecute(ASender);
    AddShiftingRegister: AAddShiftingRegisterExecute(ASender);
    AddClockGenerator:  if aAddClockGenerator.Tag = 0 then
                          aAddClockGeneratorExecute(ASender)
                        else AAddLineExecute(ASender);
    SetNegationPoint: ASetNegationPointExecute(ASender);
    Remove: ARemoveExecute(ASender);
  end;
end;

procedure TForm1.aSetNegationPointExecute(Sender: TObject);
begin
  ActAction := AddLine;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
end;

procedure TForm1.aShowOptionsGeneralExecute(Sender: TObject);
begin
  with FormOptionsGeneral do
    if Visible or (Tag = 1) then    // Tag = 1 --> hidden
      Close
    else begin
      if (Left < 0) or (Top < 0) then
      begin
        Left := 200;
        Top := 200;
      end;
      Show;
    end;
end;

procedure TForm1.aShowOptionsStandardModulesExecute(Sender: TObject);
begin
  with FormOptionsStandardModules do
    if Visible or (Tag = 1) then    // Tag = 1 --> hidden
      Close
    else begin
      if (Left < 0) or (Top < 0) then
      begin
        Left := 400;
        Top := 200;
      end;
      Show;
    end;
end;

procedure TForm1.aShowOptionsClockGeneratorExecute(Sender: TObject);
begin
  with FormOptionsClockGenerator do
    if Visible or (Tag = 1) then    // Tag = 1 --> hidden
      Close
    else begin
      if (Left < 0) or (Top < 0) then
      begin
        Left := 600;
        Top := 200;
      end;
      Show;
    end;
end;

procedure TForm1.aAboutExecute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TForm1.aAddAndExecute(Sender: TObject);
begin
  ActAction := AddAnd;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnAnd.down := true;
  FormOptionsStandardModules.btnAnd.Down := true;
  //FrameSelectoptions.SelectFrame(1);
end;

procedure TForm1.aAddClockGeneratorExecute(Sender: TObject);
begin
  ActAction := AddClockGenerator;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnClockGenerator.Down := true;
end;

procedure TForm1.aAddCouplingDiodeExecute(Sender: TObject);
begin
  ActAction := AddCouplingDiode;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnCouplingDiode.Down := true;
end;

procedure TForm1.aAddDecoderClockExecute(Sender: TObject);
begin
  ActAction := AddDecoderClock;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnDecoderClock.Down := true;
end;

procedure TForm1.aAddDecoderNoClockExecute(Sender: TObject);
begin
  ActAction := AddDecoderNoClock;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnDecoderNoClock.Down := true;
end;

procedure TForm1.aAddDelayModuleExecute(Sender: TObject);
begin
  actAction := AddDelayModule;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnDelayModule.Down := true;
end;

procedure TForm1.aAddFlipFlopExecute(Sender: TObject);
begin
  ActAction := AddFlipFlop;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnFlipFlop.Down := true;
end;

procedure TForm1.aAddFullAdderExecute(Sender: TObject);
begin
  ActAction := AddFullAdder;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnFullAdder.Down := true;
end;

procedure TForm1.aAddHalfAdderExecute(Sender: TObject);
begin
  ActAction := AddHalfAdder;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnHalfAdder.Down := true;
end;

procedure TForm1.aAddInverterExecute(Sender: TObject);
begin
  ActAction := AddInverter;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnInverter.Down := true;
end;

procedure TForm1.aAddLedExecute(Sender: TObject);
begin
  ActAction := AddLed;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnLed.down := true;
  //FrameSelectoptions.SelectFrame(1);
  FormOptionsStandardModules.btnLedClick(btnLed);
end;

procedure TForm1.aAddLineConnectorExecute(Sender: TObject);
begin
  ActAction := AddLine;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
end;

procedure TForm1.aAddLineExecute(Sender: TObject);
begin
  ActAction := AddLine;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnLine.down := true;
end;

procedure TForm1.aAddOrExecute(Sender: TObject);
begin
  ActAction := AddOr;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnOr.down := true;
  FormOptionsStandardModules.btnOr.Down := true;
  //FrameSelectoptions.SelectFrame(1);
end;

procedure TForm1.aAddShiftingRegisterExecute(Sender: TObject);
begin
  ActAction :=AddShiftingRegister;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnShiftingRegister.Down := true;
end;

procedure TForm1.aAddSwitchExecute(Sender: TObject);
begin
  ActAction := AddSwitch;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnSwitch.down := true;
  //FrameSelectoptions.SelectFrame(1);
end;

procedure TForm1.aAddTextExecute(Sender: TObject);
begin
  ActAction := AddText;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnText.down := true;
  FormOptionsStandardModules.btnTextClick(btnText);
end;

procedure TForm1.aAddXorExecute(Sender: TObject);
begin
  ActAction := AddXor;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnXor.down := true;
  FormOptionsStandardModules.btnXor.Down := true;
  //FrameSelectoptions.SelectFrame(1);
end; 

procedure TForm1.aIncreaseInputConnectorExecute(Sender: TObject);
begin
  FormOptionsStandardModules.udChangeInputCount.Position := FormOptionsStandardModules.udChangeInputCount.Position + 1;
end;

procedure TForm1.aDecreaseInputConnectorExecute(Sender: TObject);
begin
  FormOptionsStandardModules.udChangeInputCount.Position := FormOptionsStandardModules.udChangeInputCount.Position - 1;
end;

procedure TForm1.aPowerOnExecute(Sender: TObject);
begin
  //FrameSelectoptions.SelectFrame(2);
  if IsPowerOn then
  begin
    APowerOn.Caption := '&Einschalten';     // switch off
    APowerOn.Hint := 'Einschalten';
    SetEditActions(true);
    SetAction(TmpAction, Sender);

    btnPowerOn.Down := false;
    IsPowerOn := false;

    FormOptionsStandardModules.EnableAllButtons(true);
    if FormOptionsStandardModules.Tag = 1 then // is hidden
      FormOptionsStandardModules.Show;
    FormOptionsClockGenerator.EnableAll(false);
    if FormMainOptions.cbClockGeneratorView.Checked then
      FormOptionsClockGenerator.Hide;      

    Simulation.SwitchOff;
    Simulation.Paint;
  end else begin
    APowerOn.Caption := '&Ausschalten';     // switch on
    APowerOn.Hint := 'Ausschalten';
    TmpAction := ActAction;
    ActAction := PowerOn;
    ObjectList.GActAction := ActAction;
    UnCheckAllButtons;
    SetEditActions(false);

    btnPowerOn.Down := true;
    IsPowerOn := true;

    if FormMainOptions.cbStandardModulesView.Checked then
      FormOptionsStandardModules.Hide;
    FormOptionsStandardModules.EnableAllButtons(false);
    if Simulation.ClockGeneratorExists then
    begin
      FormOptionsClockGenerator.EnableAll(true);
      if FormOptionsClockGenerator.Tag = 1 then // is hidden
        FormOptionsClockGenerator.Show;
    end else if FormMainOptions.cbClockGeneratorView.Checked then
        FormOptionsClockGenerator.Hide;  

    Simulation.SwitchOn;
    Simulation.Paint;
  end;
  
end;

procedure TForm1.aRemoveExecute(Sender: TObject);
begin
  ActAction := Remove;
  ObjectList.GActAction := ActAction;
  UnCheckAllButtons;
  btnRemove.Down := true;
end;

procedure TForm1.aRePaintExecute(Sender: TObject);
begin
  Simulation.Paint;
end;

procedure TForm1.aNewExecute(Sender: TObject);
var DoIt: boolean;
    Result: integer;
begin
  DoIt := false;
  if not ObjectList.GHasChanged then
    DoIt := true
  else
  begin
    Result := Application.MessageBox('Die aktuelle Simulation wurde nicht gespeichert. ' +
      'Wollen sie die nderungen speichern?', PChar('Beenden'),
        MB_YESNOCANCEL);
    if Result = IDNO then
      DoIt := true
    else if Result = IDYES then
    begin
      ASaveExecute(Sender);
      DoIt := true;
    end;
  end;
  if DoIt then
  begin
    NewSimulation(Sender);
  end;
end;

procedure TForm1.aOpenExecute(Sender: TObject);
var Result: integer;
    EString: String;
    DoIt: boolean;
begin
  DoIt := false;
  if ObjectList.GHasChanged then
  begin
    Result := Application.MessageBox('Achtung, Sie sind dabei eine neue Datei '+
      'ffnen. Wollen sie die aktuelle Simulation speichern?',
      PChar('ffnen'), MB_YESNOCANCEL);
    if Result = IDYES then
      ASaveExecute(Sender);
  end
  else Result := IDYES;

  if Result in [IDYES, IDNO] then
    if OpenDialog.Execute then
    begin
      NewSimulation(Sender);
      if not IsPowerOn then
        ObjectList.GActAction := ActAction
      else APowerOnExecute(Sender);

      EString := Simulation.LoadFromFile(OpenDialog.FileName, false);

			if EString = '' then
				DoIt := true
			else
				if  EString = '0' then
					Showmessage('Unbekanntes Dateiformat')
				else
				begin
					Result := Application.MessageBox(PChar('Die Datei wurde von einer neueren Version '+
						'('+EString+') erstellt. Soll versucht werden die Version trotzdem zu ffnen?'),
						PChar('ffnen'), MB_YESNO);
					if Result = IDYES then
					begin
						EString := Simulation.LoadFromFile(OpenDialog.FileName, true);
						DoIt := true;
					end;
				end;
			if DoIt then
			begin
				Simulation.Paint;
				Datei := OpenDialog.FileName;
				RefreshForms;
        if not IsPowerOn then
          ObjectList.GActAction := ActAction
        else APowerOnExecute(Sender);
      end;
    end;
end;

procedure TForm1.aOptionsExecute(Sender: TObject);
begin
  FormMainOptions.ShowModal;
end;

procedure TForm1.aSaveAsExecute(Sender: TObject);
var Result: integer;
begin
  if IsLWS then
    SaveDialog.FileName := RemoveExtension(Datei) + '.sim';
  if SaveDialog.Execute then
  begin
    Result := IDYES;
    if FileExists(SaveDialog.FileName) then
      Result := Application.MessageBox('Es existiert bereits eine gleichnamige Datei.'#13
      + 'Soll diese berschrieben werden?', PChar('Speichern'),
      MB_YESNO);
    if (Result = IDYES) then
    begin
      if Simulation.SaveToFile(SaveDialog.FileName) then
        Datei := SaveDialog.FileName
      else
        Showmessage('Fehler beim Speichern der Datei');
    end;
  end;
end;

procedure TForm1.aSaveExecute(Sender: TObject);
begin
  if (Datei = '') or IsLWS then
    ASaveAsExecute(Sender)
  else
    if not Simulation.SaveToFile(Datei) then
      Showmessage('Fehler beim Speichern der Datei');
end;

procedure TForm1.aExitExecute(Sender: TObject);
begin
  close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var Result: integer;
begin
  if ObjectList.GHasChanged then
  begin
    Result := Application.MessageBox('Die aktuelle Simulation wurde nicht gespeichert. ' +
      'Wollen sie die nderungen vor dem Beenden speichern?', PChar('Beenden'),
        MB_YESNOCANCEL);
    if Result = IDCANCEL then
      Action := caNone
    else begin
      if IsPowerOn then
        APowerOnExecute(Sender);
      if Result = IDYES then
      begin
        if Datei = '' then
        begin                                // SaveAs
          if SaveDialog.Execute then
  				begin
						Result := IDYES;
						if FileExists(SaveDialog.FileName) then
							Result := Application.MessageBox('Es existiert bereits eine gleichnamige Datei.'#13
							+ 'Soll diese berschrieben werden?', PChar('Speichern'),
							MB_YESNO);
						if (Result = IDYES) then
						begin
							if Simulation.SaveToFile(SaveDialog.FileName) then
								Datei := SaveDialog.FileName
							else
								Showmessage('Fehler beim Speichern der Datei');
						end;
					end else
            Action := caNone
        end else                             // Save
          if not Simulation.SaveToFile(Datei) then
            Showmessage('Fehler beim Speichern der Datei');
      end;
    end;
  end else
    if IsPowerOn then
        APowerOnExecute(Sender);

  if Action <> caNone then      // if definite Close then Save
    GlobalSave;
end;

procedure TForm1.ImportClick(Sender: TObject);
var ALoader: LS_LWSLoader;
  Result: integer;
begin
  Result := IDNo;
  if ObjectList.GHasChanged then
  begin
    Result := Application.MessageBox('Achtung, Sie sind dabei eine neue Datei '+
      'ffnen. Wollen sie die aktuelle Simulation speichern?',
      PChar('ffnen'), MB_YESNOCANCEL);
    if Result = IDYES then
      ASaveExecute(Sender);
  end;

  if not (Result = IdCancel) then
  begin
    ALoader := Nil;
  	if OpenDialogLWS.Execute then
			try
				NewSimulation(Sender);
        if not IsPowerOn then
          ObjectList.GActAction := ActAction
        else APowerOnExecute(Sender);

				ALoader := LS_LWSLoader.create;      // laod
				if ALoader.Load(OpenDialogLWS.FileName, Simulation.MainBox) then
				begin
					ObjectList.GHasChanged := true;
          Datei := OpenDialogLWS.FileName;
          IsLWS := true;
				end else begin
					Simulation.Paint;
					showmessage('Importieren fehlgeschlagen!');
					ObjectList.GHasChanged := false;
					ANewExecute(Sender);
				end;
			finally
				if ALoader <> Nil then ALoader.Free;
			end;
  end;
  Simulation.Paint;
end;



procedure TForm1.KonvertClick(Sender: TObject);
var ALoader: LS_LWSLoader;
    Result: integer;
    ASimulation: TSimulation;
begin
  ALoader := Nil;
  ASimulation := Nil;
  if OpenDialogLWS.Execute then
  begin
    SaveDialog.FileName := RemoveExtension(OpenDialogLWS.FileName) + '.sim';
    if SaveDialog.Execute then
    	try
				Result := IDYES;
				if FileExists(SaveDialog.FileName) then
					Result := Application.MessageBox('Es existiert bereits eine gleichnamige Datei.'#13
						+ 'Soll diese berschrieben werden?', PChar('Speichern'),
						MB_YESNO);
				if (Result = IDYES) then
				begin
					ALoader := LS_LWSLoader.create;
					ASimulation := TSimulation.Create(Nil);
					if ALoader.Load(OpenDialogLWS.FileName, ASimulation.MainBox) and ASimulation.SaveToFile(SaveDialog.FileName) then
					begin
						Simulation.Paint;
						showmessage('Erfolgreich konvertiert.');
					end else begin
						Simulation.Paint;
						showmessage('Konvertieren fehlgeschlagen!');
					end;
				end;
			finally
				if ALoader <> Nil then ALoader.Free;
				if ASimulation <> Nil then ASimulation.Free;
			end;
  end;
  Simulation.Paint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  application.HintPause := 500;
  application.HintHidePause := 9999;
  First := true;

  paInfoLeft := TDynDockPanel.Create(self);
  paInfoLeft.Left := 0;
  paInfoLeft.Align := alLeft;

  paInfoRight := TDynDockPanel.Create(self);
  paInfoRight.Left := self.ClientWidth;
  paInfoRight.Align := alRight;

  ObjectList.gBmp := TBitMap.Create;
  Simulation := TSimulation.Create(PageControl2);
  ObjectList.gSize := 2;
  Datei := '';
  IsPowerOn := false;

  AAddLine.Hint := 'Leitungen ziehen' + #13#10 +
                   'Verbindungspunkt setzen / entfernen' + #13#10 +
                   'Negationspunkt setzen / entfernen';
  AAddCouplingDiode.Hint := 'Leitungen koppeln' + #13#10 +
                            'Kopplung aufheben';


  If (ParamCount > 0) and (FileExists(ParamStr(1))) then
    tLoad.Enabled := true;

  Application.OnMessage := ApplicationEventsMessage;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if First then
  begin
    First := false;
    SetAction(AddLine, Sender);
    FormOptionsClockGenerator.EnableAll(false);

    GlobalLoad;

    ObjectList.gAutoRePaint := true;
    Simulation.Paint;
  end;
end;

procedure TForm1.tLoadTimer(Sender: TObject);
var EString: String;
  DoIt: boolean;
  Result: integer;
begin
  tLoad.Enabled := false;
  DoIt := false;

  EString := Simulation.LoadFromFile(ParamStr(1), false); 
  if EString = '' then
    DoIt := true
  else
    if  EString = '0' then
      Showmessage('Unbekanntes Dateiformat')
    else
    begin
      Result := Application.MessageBox(PChar('Die Datei wurde von einer neueren Version '+
        '('+EString+') erstellt. Soll versucht werden die Version trotzdem zu ffnen?'),
        PChar('ffnen'), MB_YESNO);
      if Result = IDYES then
      begin
        EString := Simulation.LoadFromFile(ParamStr(1), true);
        DoIt := true;
      end;
    end;
  if DoIt then
  begin
    Simulation.Paint;
    Datei := ParamStr(1);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Simulation.Free;
  ObjectList.GBmp.Free;
end;

procedure TForm1.RefreshForms;
begin
  FormOptionsGeneral.RefreshForm;
  FormOptionsStandardModules.RefreshForm;
  FormOptionsClockGenerator.RefreshForm;
  if Simulation.ClockGeneratorExists then
    if aAddClockGenerator.Tag = 0 then
    begin
      aAddClockGenerator.Tag := 1;   // Clockgenerator now exists
      aAddClockGenerator.Enabled := false;
      aAddLineExecute(Nil);
    end else
  else if Form1.aAddClockGenerator.Tag <> 0 then
    begin
      aAddClockGenerator.Tag := 0;      // no CG exists
      aAddClockGenerator.Enabled := true;
    end;
end;

procedure TForm1.NewSimulation(Sender: TObject);
begin
  Simulation.Free;
  Simulation := TSimulation.Create(PageControl2);
  Datei := '';
  ObjectList.gHasChanged := false;
  //FrameSelectoptions.SelectFrame(0);
  if not IsPowerOn then
    ObjectList.GActAction := ActAction
  else APowerOnExecute(Sender);
  aAddClockGenerator.Tag := 0;
  aAddClockGenerator.Enabled := true;
  RefreshForms;
end;

procedure TForm1.ApplicationEventsMessage(var Msg: tagMSG; var Handled: Boolean);
begin
  if Msg.Message = WM_LBUTTONUP then
    if Assigned(Simulation) then Simulation.Paint;
end;

end.
