(*
FrameSelect.pas
Copyright (C) 2006  Christian Brugger <brugger.christian(AT)web.de>

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version. This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
details. You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc., 51
Franklin St, Fifth Floor, Boston, MA 02110, USA
*)
unit SelectFrames;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFrameSelectOptions = class(TFrame)
    cBoxSelect: TComboBox;
    procedure cBoxSelectChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    procedure RefreshFrames;
    procedure SelectFrame(AIndex: integer);
  end;

implementation

{$R *.dfm}

uses Haupt;

var IsSet: boolean = false;

procedure TFrameSelectOptions.SelectFrame(AIndex: Integer);
begin
  cBoxSelect.ItemIndex := AIndex;
  Form1.FrameOptionsGeneral.Visible := false;
  Form1.FrameOptionsStandardModules.Visible := false;
  Form1.FrameOptionsClockGenerator.Visible := false;
  Form1.FrameOptionsIc.Visible := false;
	case AIndex of
		0: Form1.FrameOptionsGeneral.Visible := true;
		1: begin
			Form1.FrameOptionsStandardModules.Visible := true;
			if not IsSet then
  		begin
				Form1.FrameOptionsStandardModules.tBarSize.Position := 3;
				IsSet := true;
			end;
    end;
    2: Form1.FrameOptionsClockGenerator.Visible := true;
    3: Form1.FrameOptionsIc.Visible := true;
	end;
  RefreshFrames;
end;

procedure TFrameSelectOptions.cBoxSelectChange(Sender: TObject);
begin
  SelectFrame(cBoxSelect.ItemIndex);
end;

procedure TFrameSelectOptions.RefreshFrames;
begin
  case cBoxSelect.ItemIndex of
    0: Form1.FrameOptionsGeneral.RefreshFrame;
    1: Form1.FrameOptionsStandardModules.RefreshFrame;
    
    //3: Form1.FrameOptionsIc.RefreshFrame;
  end;
end;

end.
