unit MiscFunc;

{///////////////////////////////////////////////////////////////////////////////
// Beschreibung :  Die Unit miscfunc enthlt viele kleine Hilfsfunktionen
                  aus den unterschiedlichsten Bereichen.
// erstellt am  : ???
////////////////////////////////////////////////////////////////////////////////
// nderungen:
    21.9.2001 Neue Funktion GetFileDate
    31.12.2001 Neue Funktionen fr den Drucker
    15.1.2002 Neue Funktionen: ListToTStrings, ListToNewTStringList,
                  ListFromTStrings und ClassHierarchyAsList
    11.2.2002 Neue Funktionen: AnalizeLinePoint, AnalizeLineLine, AnalizeLineRect,
                  FloatLessEqual, FloatLess, FloatGreaterEqual und FloatGreater
    15.2.2002 Neue Funktion: GetPolygonRect
    10.3.2002 Neue Funktion: CountEqualChars
    14.3.2002 Neue Funktion: DrawTGraphic
    13.7.2002 Neue Funktion: BigDiv
    28.9.2002 Neue Funktionen: IsFileReadOnly, GetHomoString
    9.2.2003 Neue  Funktion: CenterPoint
    23.4.2003 Neue  Funktion: IsIntf
    19.7.2003 Neue Funktion: GetKeyboardShiftState
     					Bugfix in WinkelOfPoint
    6.9.2003 Bugfix in CountEqualChars (Danke an Helmut Helwig)
///////////////////////////////////////////////////////////////////////////////}
// Delphi 5 Implementation
//
// Copyright (c) 2000 by Richard Kaspar
// ("http://www.kasparsoft.de")
//
// Definitions:
// - "Package" refers to the collection of files distributed by
//   the Copyright Holder, and derivatives of that collection of
//   files created through textual modification.
// - "Standard Version" refers to such a Package if it has not
//   been modified, or has been modified in accordance with the
//   wishes of the Copyright Holder.
// - "Copyright Holder" is whoever is name in the copyright or
//   copyrights for the package.
// - "You" is you, if you're thinking about copying or distributing
//   this Package.
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Package"), to deal in the Package without restriction,
// including without limitation the rights to use, copy, modify,
// merge, publish, distribute, sublicense, and/or sell copies of the
// Package, and to permit persons to whom the Package is furnished
// to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Package.
//
// You may modify your copy of this Package in any way, provided
// that you insert a prominent notice in each changed file stating
// how and when you changed a file, and provided that you do at
// least one of the following:
//
// a) allow the Copyright Holder to include your modifications in
// the Standard Version of the Package.
//
// b) use the modified Package only within your corporation or
// organization.
//
// c) rename any non standard executables, units, and classes so
// the names do not conflict with standard executables, units, and
// classes, and provide a separate manual page that clearly documents
// how it differs from the standard version.
//
// d) make other distribution arrangements with the Copyright Holder.
//
// The name of the Copyright Holder may not be used to endorse or
// promote products derived from this Package without specific prior
// written permission.
//
// THE PACKAGE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
// CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
// TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
// PACKAGE OR THE USE OR OTHER DEALINGS IN THE PACKAGE.
{$I RAK.INC}

interface

{$WARN SYMBOL_PLATFORM OFF}

uses windows, Messages, Forms, SysUtils, Graphics, Classes, misctype,
  Printers, Math;


// FreeTObject lscht ein Objekt aus dem Speicher und setzt die Referenz auf nil
procedure FreeTObject(var Objekt);

// SignToInt gibt bei einer positiven Zahl 1, beieiner negativen Zahl -1 und bei 0 0 zurck
function SignToInt(Zahl: integer): integer; overload;
function SignToInt(Zahl: extended): integer; overload;

// Die Decide-Funktionen bilden das "?:"-Konstrukt aus C nach.
function Decide(What: boolean; IsTrue: string; IsFalse: string): string; overload;
function Decide(What: boolean; IsTrue: integer; IsFalse: integer): integer; overload;
function Decide(What: boolean; IsTrue: extended; IsFalse: extended): extended; overload;

// BoolToStr liefert fr true '1' und fr false '0' zurck
function BoolToStr(Value: boolean): string;
// Wandelt einen String in einen boolean-Wert um. true: '-1','1','ja','wahr','true','yes'; false: '0','nein','falsch','no','false'
function StrToBool(Value: string): boolean;
// StrToBoolDef ist wie StrToBool, nur dass 'Def' zurckgeliefert wird, wenn mit Value keiner der erlaubten Werte bergeben wurde
function StrToBoolDef(Value: string; Def: boolean): boolean;

function HexToInt(HexValue: string; Default: integer = -1): integer;

// Die Tausche-Funktionen tauschen die Werte der beiden bergebenen Variablen; (Dafr gibt es bestimmt eine Pascal-Funktion, ich hab sie aber nicht gefunden)
procedure Tausche(var v1, v2: byte); overload;
procedure Tausche(var v1, v2: integer); overload;
procedure Tausche(var v1, v2: extended); overload;
procedure Tausche(var v1, v2: string); overload;

// KleinerGroesser sorgt dafr, dass in v1 der kleinere und v2 der grere Wert von den beiden bergebenen steht
procedure KleinerGroesser(var v1, v2: byte); overload;
procedure KleinerGroesser(var v1, v2: integer); overload;
procedure KleinerGroesser(var v1, v2: extended); overload;
// Statt GetKleiner sollte man die Funktion Min aus der Unit Math verwenden
function GetKleiner(v1, v2: integer): integer; overload;
function GetKleiner(v1, v2: extended): extended; overload;
// Statt GetGroesser sollte man die Funktion Max aus der Unit Math verwenden
function GetGroesser(v1, v2: integer): integer; overload;
function GetGroesser(v1, v2: extended): extended; overload;
//CheckMinMax prft, ob iMin <= iVar <= iMax ist. Falls nicht, dann nimmt iVar entw. den Wert von iMin oder iMax an
//Hinweis: Wenn der Wert iMin grer als iMax ist, dann wird dies zuerst korrigiert
function CheckMinMax(var iVar: byte; iMin, iMax: byte): integer; overload;
function CheckMinMax(var iVar: integer; iMin, iMax: integer): integer; overload;
function CheckMinMax(var iVar: extended; iMin, iMax: extended): integer; overload;
//IsBetween prft, ob iMin <= iVar <= iMax ist.
//Hinweis: Wenn der Wert iMin grer als iMax ist, dann wird dies zuerst korrigieert
function IsBetween(iValue, iMin, iMax: integer): boolean; overload;
function IsBetween(iValue, iMin, iMax: extended): boolean; overload;

//ToRaster verndert X so, dass folgendes gilt: X = X0 + XStep * int, wobei int eine beliebige ganze Zahl ist und X mglichst nahe an seinem Ausganswert liegen soll
//Beispiel: X := 2.9; ToRaster(X, -1, 2); Jetzt ist X = 3   (3 = -1 + 2 * 2); whre X = 1.9 gewesen, dann wre daraus 1 gemacht worden (1 = -1 + 2 * 1)
procedure ToRaster(var X: extended; X0, XStep: extended); overload;

// Mit Drehe kann man einen Punkt um einen bestimmten Winkel um einen Drehpunkt im Uhrzeigersinn drehen; Der Winkel wird in zehntel Grad angegeben
// Beispiel: X := 100; Y := 0; Drehe(X,Y,900); Jetzt ist X = 0 und Y = 100; Drehung um 90 Grad um den Nullpunkt
procedure Drehe(var X,Y: integer; Winkel: integer);  overload;
procedure Drehe(var X,Y: integer; NX,NY: integer; Winkel: integer); overload;
// Mit DotLine kann man eine echte Punktlinie zeichnen, also ein Pixel gezeichnet ein Pixel ausgelassen
procedure DotLine(Canvas: TCanvas; X1, Y1, X2, Y2: integer);

{  Die ganzen folgenden Listfunktionen halten eine Liste von Werten in Form eines Strings.
  Damit die einzelnen Werte getrennt werden knnen, muss es mindestens ein Zeichen geben,
  das als Trennzeichen verwendet wird. Diese Trennzeichen knnen dann nicht innerhalb eines
  Wertes verwendet werden. Das Defaulttrennzeichen ist das Komma ',', es knnen aber auch
  andere Trennzeichen verwendet werden. Folgen zwei Trennzeichen unmittelbar hintereinander,
  dann enthlt die Liste dort einen Leerstring als Element.
  Damit lsst sich einiges mit wenig Code implmentieren (z.B. einfache Parser-Aufgaben),
  diese Funktionen glnzen aber nicht durch hohe Performanz
  ACHTUNG:  Es gibt einen Fall, mit dem die Listfunktionen nicht zurechtkommen:
            Eine Liste, die als einziges Element einen Leerstring enthlt wird
            wie eine leere  Liste behandelt
  Beispiele:
  Trennzeichen: ','
  Liste: 'das,ist,eine Liste'
  Die Liste enthlt drei Werte: 'das', 'ist' und 'eine Liste';
  Liste: ',noch,ne,,Liste'
  Die Liste enthlt fnf Werte: '', 'noch', 'ne', '' und 'Liste';
  Trennzeichen: '/\:'  (Sowohl '/' als auch '\' und ':' werden als Trennzeichen interpretiert)
  Liste: 'c:\Ordner/Unterordner\Dateiname'
  Die Liste enthlt fnf Werte: 'c', '', 'Ordner', 'Unterordner' und 'Dateiname';
}
// ListAppend fgt der Liste AList das neue Element NewItem hinten an und trennt es mit Trennzeichen ab
function ListAppend(AList: string; NewItem: string; Trennzeichen: char = ','): string; overload;
function ListAppend(AList: string; NewItem: integer; Trennzeichen: char = ','): string; overload;
// ListLen gibt zurck, wieviele Elemente sich in der Liste AList befinden
function ListLen(AList: string; Trennzeichen: string = ','): integer;
// ListGetAt gibt das Element an der Stelle Idx der Liste AList zurck; Idx=0 ist das erste Element
function ListGetAt(AList: string; Idx: integer; Trennzeichen: string = ','): string;
// ListSetAt berschreibt das Element an der Stelle Idx der Liste mit NewItem; Idx=0 ist das erste Element
function ListSetAt(AList: string; NewItem: string; Idx: integer; Trennzeichen: string = ','): string;
// ListDeleteAt lscht das Element an der Stelle Idx aus der Liste
function ListDeleteAt(AList: string; Idx: integer; Trennzeichen: string = ','): string;
// ListFindNoCase gibt den Index des Elementes Item in der Liste AList zurck; Wenn Item nicht in AList enthalten ist, dann wird -1 zurckgegeben
function ListFindNoCase(AList: string; Item: string; Trennzeichen: string = ','): integer;
//ListSchnittmenge gibt eine Liste aller Elemente von Liste 'Liste1' zurck, die auch in der Liste 'Liste2' enthalten sind
function ListSchnittmenge(List1, List2: string; Trennzeichen: string = ','): string;
//ListToTStrings:Die Elemente einer Liste werden in eine TStrings-Objekt kopiert
procedure ListToTStrings(List: string; Strings: TStrings; Trennzeichen: string = ',');
//ListToNewTStringList: Es wird eine neue Instanz von TStringList erzeugt und diese mit den Elemente der Liste gefllt.
//Achtung: Der Aufrufer wird zum Besitzer von TStringList und muss diese auch wieder freigeben
function ListToNewTStringList(List: string; Trennzeichen: string = ','): TStringList;
//ListFromTStrings: Aus den Elementen eines TStrings-Objekt wird eine neue Liste erzeugt und zurckgegeben
//Achtung: Es wird nicht geprft, ob die Elemente des TStrings-Objektes das Trennzeichen enthalten
function ListFromTStrings(Strings: TStrings; Trennzeichen: char = ','): string;
//ClassHierarchyAsList:Die Namen einer Klasse und aller Klassen von denen die Klasse abgeleitet ist,
//wird als Liste zurckgegeben. Die Ausgangsklasse ist dann das erste Element der Liste
//UntilClass bestimmt, dass die Liste nur bis zu dieser Klasse aufgebaut wird.
//Die Klasse UntilClass selbst ist nicht in der Liste enthalten
function ClassHierarchyAsList(ClassType: TClass; UntilClass: TClass = nil; Trennzeichen: char = ','): string;

// ExtLine gibt die Einzelkoordinaten einer Linie in Form von TExtLine zurck
function ExtLine(X1, Y1, X2, Y2: extended): TExtLine; overload;
function ExtLine(Point1, Point2: TExtPoint): TExtLine; overload;
function ExtPoint(X, Y: extended): TExtPoint;
function ExtPointsEqual(p1, p2: TExtPoint): boolean;
function CenterPoint(p1, p2: TExtPoint): TExtPoint; overload;
function CenterPoint(p1, p2: TPoint): TPoint; overload;
function FloatEqual(e1, e2: extended): boolean;
function FloatLessEqual(e1, e2: extended): boolean;
function FloatLess(e1, e2: extended): boolean;
function FloatGreaterEqual(e1, e2: extended): boolean;
function FloatGreater(e1, e2: extended): boolean;

{  Von Delphi bzw. Windows wird der Typ TRect angeboten, mit dem man
  ein Rechteck in Pixelkoordinaten angeben kann. Fr gerteunabhngige
  Koordinaten eignen sich allerdings Float-Werte besser als Integer-Werte.
  Deshalb habe ich den Typ TExtRect eingefhrt, auf den sich viele der folgenden
  Funktionen beziehen.
}
// ExtBounds bildet aus Positions- und Grenkoordinaten ein TExtRect
function ExtBounds(Left, Top, Width, Height: extended): TExtRect;
// ExtRect bildet aus Kantenkoordinaten ein TExtRect (s.a Delphi-Funktion Rect)
function ExtRect(Left, Top, Right, Bottom: extended): TExtRect; overload;
function ExtRect(ARect: TRect): TExtRect; overload;
// RoundRect wandelt ein TExtRect in ein TRect um
function RoundRect(ARect: TExtRect): TRect;
// NormalizeRect stellt sicher, dass Left < Right und Top < Bottom
function NormalizeRect(const ARect: TRect): TRect; overload;
function NormalizeRect(const ARect: TExtRect): TExtRect; overload;
// CheckPaintRect prft, ob ARect berhaupt eine Ausdehnung hat und vergrert evtl. Botton und Right um ein Pixel
procedure CheckPaintRect(var ARect: TRect);
// AlignRect platziert OrgRect innerhalb BorderRect so, wie es die Align-Parameter festlegen
function AlignRect(const OrgRect, BorderRect: TRect;
  HorzAlign: THorzAlign; VertAlign: TVertAlign): TRect; overload;
function AlignRect(const OrgRect, BorderRect: TExtRect;
  HorzAlign: THorzAlign; VertAlign: TVertAlign): TExtRect; overload;
// FitRect skaliert Width und Height(bzw. OrgRect) so, dass es den Platz von BorderWidth und BorderHeight mglichst gut ausnutzt, wobei die Seitenverhltnisse von Width und Height beibehalten werden
procedure FitRect(var Width, Height: integer; BorderWidth, BorderHeight: integer); overload;
procedure FitRect(var Width, Height: extended; BorderWidth, BorderHeight: extended); overload;
function FitRect(const OrgRect, BorderRect: TRect;
  HorzAlign: THorzAlign = haCenter; VertAlign: TVertAlign = vaCenter): TRect; overload;
function FitRect(const OrgRect, BorderRect: TExtRect;
  HorzAlign: THorzAlign = haCenter; VertAlign: TVertAlign = vaCenter): TExtRect; overload;
      // Die Parameter XAnker, YAnker legen fest, um welchen Punkt OrgRect skalliert wird
function FitRect(const OrgRect, BorderRect: TRect; XAnker, YAnker: integer): TRect; overload;
function FitRect(const OrgRect, BorderRect: TExtRect; XAnker, YAnker: extended): TExtRect; overload;
      // Der Parameter AlignCorner legt fest, um welchen Punkt OrgRect skalliert wird
function FitRect(AlignCorner: TCorner; const OrgRect: TExtRect; BorderWidth, BorderHeight: extended): TExtRect; overload;
{Die folgenden Funktionen sind Vektorfunktionen und ermitteln z.B. Schnittpunkte
}
// InRect gibt zurck, ob sich die Koordinate X,Y innerhalb des Rechteckes ARect beindet
function InRect(X,Y: integer; ARect: TRect): boolean;
// InGraphicRect unterscheidet sich von InRect nicht
function InGraphicRect(X,Y: integer; ARect: TRect): boolean; overload;
function InGraphicRect(X,Y: extended; ARect: TExtRect): boolean; overload;
function InGraphicRect(APoint: TExtPoint; ARect: TExtRect): boolean; overload;
// InGraphicRect gibt zurck, ob sich IsRect komplett innerhalb von InRect befindet
function InGraphicRect(IsRect, InRect: TRect): boolean; overload;
function InGraphicRect(IsRect, InRect: TExtRect): boolean; overload;
// TouchGraphicRects gibt zurck, ob sich Rect1 und Rect2 berhren. Ein Aneinanderstoen, z.B. Rect1.Right = Rect2.Left, gilt nicht als Berhrung
function TouchGraphicRects(Rect1, Rect2: TRect): boolean;

//ACHTUNG: Die nchsten drei Funktionen sind noch nicht getestet. Man sollte sie also noch nicht verwenden
// AnalizeLinePoint ermittelt relative Lage eines Punktes zu einer Linie
procedure AnalizeLinePoint(Line: TExtLine; Point: TExtPoint; var Result: TAnalizeLinePointResult);
// AnalizeLineLine ermittelt die Schnittpunkte Zweier Linien
procedure AnalizeLineLine(Line1, Line2: TExtLine; var Result: TAnalizeLineLineResult);
// AnalizeLineRect ermittelt die Schnittpunkte einer Linie mit einem Rechteck
procedure AnalizeLineRect(Line: TExtLine; Rect: TExtRect; var Result: TAnalizeLineRectResult);

// OffsetExtRect verschiebt ein Rechteck
procedure OffsetExtRect(var ARect: TExtRect; XOff, YOff: extended);
// GrowExtRect vergrert ein Rechteck in jede Richtung
procedure GrowExtRect(var ARect: TExtRect; Off: extended);

{ Die folgenden Funktionen dienen der String-Verarbeitung
}
// CutLeft schneidet vom Anfang eines Strings eine bestimmte Anzahl von Zeichen ab.
function CutLeft(const str: string; Count: integer): string;
// CutRight schneidet vom Ende eines Strings eine bestimmte Anzahl von Zeichen ab.
function CutRight(const str: string; Count: integer): string;
// Left gibt den Anfang eines Stringes zurck
function Left(const str: string; Count: integer): string;
// Right gibt das Ende eines Stringes zurck
function Right(const str: string; Count: integer): string;
// PosRight sucht von Rechts nach Links den string 'Substr' innerhalb des Strings 'S' ab dem Zeichen 'StartIdx'; Wenn StartIdx = 0, dann wird der komplette String abgesucht
function PosRight(Substr, S: string; StartIdx: integer = 0): integer; overload;
// PosRight sucht von Rechts nach Links eines der Zeichen 'Zeichenmenge' innerhalb des Strings 'S' ab dem Zeichen 'StartIdx'; Wenn StartIdx = 0, dann wird der komplette String abgesucht
function PosRight(Zeichenmenge: TZeichenmenge; S: string; StartIdx: integer = 0): integer; overload;
// PosLeft sucht von Links anch Rechts eines der Zeichen 'Zeichenmenge' innerhalb des Strings 'S' ab dem Zeichen 'StartIdx'; Wenn StartIdx = 0, dann wird der komplette String abgesucht
function PosLeft(Zeichenmenge: string; S: string; StartIdx: integer = 0): integer; overload;
function PosLeft(Zeichenmenge: TZeichenmenge; S: string; StartIdx: integer = 0): integer; overload;
// CountEqualChars gibt zurck wieviele Zeichen von Str1 und Str2 am Anfang bereinstimmen
function CountEqualChars(Str1, Str2: string; CharSensitive: boolean = false): integer;
// Exchange ersetzt innerhalb des Strings 'str' den Teilstring, der durch SubStrPos und SubStrCount bestimmt wird, durch den String 'NewSubStr'
function Exchange(const str: string; SubStrPos, SubStrCount: integer;
  const NewSubStr: string): string;
// InsertString fgt den String "SubStr" in den String "str" an der Position "Position" ein; Bsp.: InsertStr('ade', 'bc', 2) liefert 'abcde' zurck
function InsertString(const str, SubStr: string; Position: integer): string;
// DeleteXMLTag entfernt aus dem string den einrahmenten tag 'TagName'
//Beispiel DeleteXMLTag(' <EinTag X="1">Beliebiger Inhalt</EinTag>', 'EinTag') gibt 'Beliebiger Inhalt' zurck
function DeleteXMLTag(xml, TagName: string): string;
// GetHomoString erzeugt einen String mit der Lnge Count, der nur aus FillChar besteht.
function GetHomoString(FillChar: char; Count: integer): string;

// LabelCaption entfernt "&" aus einem String; z.B. LabelCaption('&Proctor && Gambel') = 'Proctor & Gambel'
function LabelCaption(Caption: string): string;
// Statt ReplaceSubStr sollte man die Delphi-Funktion StringReplace verwenden
function ReplaceSubStr(Str, FindStr,ReplaceStr: string): string;
// StrToSek erwartet einen String vom Format min:sec und gibt die Zeit in Sekunden zurck; z.B. '3:34' wird als 214 zurckgegeben
function StrToSek(Str: string): word;
// StrToSQL schtzt Apostrophs "'" in einem String; z.B. Aus "Kein ' verwenden" wird "Kein '' verwenden"
function StrToSQL(Str: string): string;

{  Die folgenden Funktionen verarbeiten Zahlen
}
// StBigInt macht das gleiche wie trunc oder int, nur dass die Nachkommastellen nicht entfernt werden, sondern auf die absolut nchst hhere Zahl aufgefllt werden; z.B.: BigInt(2.3) = 3; BigInt(-2.3) = -3; BigInt(2) = 2
function BigInt(Zahl: extended): integer;
// Statt HigherInt sollte man die Funktion Ceil aus der Unit Math verwenden
function HigherInt(Zahl: extended): integer;
// Statt LowerInt sollte man die Funktion Floor aus der Unit Math verwenden
function LowerInt(Zahl: extended): integer;
// RoundInt macht das gleiche wie round, auer dass man eine andere Rundungsgrenze als 0,5 angeben kann
function RoundInt(Zahl, Grenze: extended): integer;
// Rest liefert die Nachkommastellen zurck; z.B. Rest(2.34) = 0.34; Rest(-2.34) = -0.34
function Rest(Zahl: extended): extended;
// BigDiv dividiert die Zahl1 durch die Zahl2. Sollte es einen Rest geben, dann wird das Ergebnis um 1 erhht
function BigDiv(Zahl1, Zahl2: integer): integer;

{  Die folgenden Funktionen sind fr die Umwandlung zw. Strings und Zahlen zustndig
}
// FloatToNormStr ist hnlich zu FloatToStr. Bei einem NormStr ist der Dezimalpunkt aber immer ein ".", egal auf welche Sprache das Betriebsystem eingestellt ist
function FloatToNormStr(Zahl: extended; Nachkommastellen: integer = -1): string;
function NormStrToFloat(Str: string): extended; overload;
function NormStrToFloat(Str: string; Default: extended): extended; overload;
// StrToFloatDef ist das Gegenstck zur Delphi-Funktion StrToIntDef
function StrToFloatDef(Str: string; Default: extended): extended;
// InputToNormStr versucht eine vom Anwender eingegebene Zahl als Fliekommazahl zu interpretieren;
// Als Dezimalpunkt werden '.' und ',' akzeptiert. InputStr kann auch Tausendertrennzeichen enthalten;
// z.B. "1.000" = "1"; "1,000" = "1"; "1.000,5" = "1000.5"; "1,000.5" = "1000.5"; "10e2" = "1000"; "1.43,3" = Default
function InputToNormStr(InputStr, Default: string): string;
function InputToFloat(InputStr: string; Default: extended): extended;

// Erzeugt aus einem Polygon der Form TPolygon eine Winows Region
// ACHTUNG die Region muss mit der API-Funktion DeleteObject wieder freigegeben werden!
function CreatePolyRgn(Poly: TPolygon): HRGN;

function GetPolygonRect(Poly: TPolygon): TRect; overload;
function GetPolygonRect(Poly: TExtPolygon): TExtRect; overload;
function MovePolygon(Poly: TExtPolygon; OffX, OffY: extended): TExtPolygon; overload;

// ComponentByName sucht nach einer Komponente mit den Namen 'ComponentName', von der die
// Komponente 'Owner' der Owner ist
function ComponentByName(Owner: TComponent; ComponentName: string): TComponent;
// ProcessMessages ist so hnlich wie Application.ProcessMessages nur mit dem
// Unterschied, dass nur 'MsgID'-Messages abgearbeitet werden; z.B. ProcessMessages(WM_PAINT)
function ProcessMessages(MsgID: UINT): boolean;

// GetFileDate ermittelt das Datum der Datei oder des Verzeichnisses
function GetFileDate(FileName: string; out FileDateTime: TDateTime;
  CreationTime: boolean): boolean;
// GetSubFolders ermittelt die direkten Unterordner eines Ordners
procedure GetSubFolders(Path: string; SubPaths: TStrings);
procedure GetFiles(Filter: string; Files: TStrings);

// IsFileReadOnly ermittelt, ob eine Datei/Ordner ReadOnly ist. Sollte es die Datei nicht geben,
// wird ermittelt, ob sie erstellt werden knnte.
function IsFileReadOnly(FileName: string): boolean;

// InitCanvas initialisiert den Canvas auf Defaultwerte
procedure InitCanvas(Canvas: TCanvas);

{Die folgenden Funktionen ermitteln Druckereinstellungen
}
function GetPrinterPaperHeightInPixel: integer;
function GetPrinterPaperWidthInPixel: integer;
function GetPrinterPaperHeightInMm: extended;
function GetPrinterPaperWidthInMm: extended;
function GetPrinterVertPixelPerInch: integer;
function GetPrinterHorzPixelPerInch: integer;
function GetPrinterVertPixelPerMm: extended;
function GetPrinterHorzPixelPerMm: extended;

function GetPrintableHeightInPixel: integer;
function GetPrintableWidthInPixel: integer;
function GetPrintableHeightInMm: extended;
function GetPrintableWidthInMm: extended;
function GetPrintableLeftBorderInPixel: integer;
function GetPrintableTopBorderInPixel: integer;
function GetPrintableLeftBorderInMm: extended;
function GetPrintableTopBorderInMm: extended;
function GetPrintableRect: TExtRect;
function GetPrintableRectInPixel: TRect;

function IsItADisplayHandle(Handle: THandle): boolean;

// DrawTGraphic gibt Graphic auf dem Canvas aus. ARect bestimmt die Position und Gre
procedure DrawTGraphic(Canvas: TCanvas; Graphic: TGraphic; ARect: TRect);

// IsIntf prft, ob eine Instanz ein bestimmtes Interface implementiert
// IsIntf ruft einfach nur die Funktion Supports auf und erspart es einem 
// eine Dummy-Variable anzulegen
function IsIntf(const Instance: IUnknown; Intf: TGUID): boolean; overload;
function IsIntf(Instance: TObject; Intf: TGUID): boolean; overload;

function GetKeyboardShiftState: TShiftState;

{$IFDEF _DEBUGIT_}
var
  DebugInt: integer;
// DebugIt schreibt hart den Text/Zahl auf den Desktop; Bei einem erneuten
// Aufruf von DebugIt wird die Ausgabe etwas nach unten versetzt
// DebugIt ist besonders dann Hilfreich, wenn ein Fehler innerhalb des normalen Programms aber
// nicht innerhalb des Debuggers auftritt, oder es Laufzeiteffekte gibt, wie zum Beispiel beim
// ShowModal eines Dialogs, wenn noch Botschaften in der Warteschlange des Hauptfenster sind.
procedure DebugIt(X: integer; Text: string); overload;
procedure DebugIt(X: integer; Zahl: extended); overload;
procedure DebugIt(X: integer; bool: boolean); overload;
procedure DebugIt(VName: string; Value: string; X: integer = 0); overload;
procedure DebugIt(VName: string; Value: extended; X: integer = 0); overload;
procedure DebugIt(VName: string; Value: boolean; X: integer = 0); overload;
{$ENDIF}

implementation

type
  // TProtectedGraphic wird nur gebraucht, damit man auch die Methoden von TGraphic aufrufen kann, die protected sind
  TProtectedGraphic = class(TGraphic);

{$IFDEF _DEBUGIT_}

var
  DebugY: integer = 0;

procedure DebugIt(X: integer; Text: string);
var
  DC : HDC;
begin
  Text := Text + '  ';
  DC := GetDc(0);
  TextOut(DC, X, DebugY+12, '                ', 16);
  TextOut(DC, X, DebugY, PChar(Text), length(Text));
  ReleaseDC(0, DC);
  inc(DebugY, 12);
  if DebugY > 1000 then
    DebugY := 0;
end;
procedure DebugIt(X: integer; Zahl: extended);
begin
  DebugIt(X, FloatToStr(Zahl));
end;
procedure DebugIt(X: integer; bool: boolean);
begin
  DebugIt(X, Decide(bool, 'true', 'false'));
end;
procedure DebugIt(VName: string; Value: string; X: integer = 0);
begin
  DebugIt(X, VName + ': ' + Value);
end;
procedure DebugIt(VName: string; Value: extended; X: integer = 0);
begin
  DebugIt(X, VName + ': ' + FloatToStr(Value));
end;
procedure DebugIt(VName: string; Value: boolean; X: integer = 0);
begin
  DebugIt(X, VName + ': ' + Decide(Value, 'true', 'false'));
end;
{$ENDIF}

procedure FreeTObject(var Objekt);
var
  Obj : TObject;
begin
  Obj := TObject(Objekt);
  TObject(Objekt) := nil;
  Obj.Free;
end;

function SignToInt(Zahl: integer): integer;
begin
  if Zahl > 0 then
    Result := 1
  else if Zahl < 0 then
    Result := -1
  else
    Result := 0;
end;

function SignToInt(Zahl: extended): integer;
begin
  if FloatEqual(Zahl, 0) then
    Result := 0
  else if Zahl > 0 then
    Result := 1
  else
    Result := -1;
end;


function Decide(What: boolean; IsTrue: string; IsFalse: string): string;
begin
  if What then
    Result := IsTrue
  else
    Result := IsFalse;
end;

function Decide(What: boolean; IsTrue: integer; IsFalse: integer): integer;
begin
  if What then
    Result := IsTrue
  else
    Result := IsFalse;
end;

function Decide(What: boolean; IsTrue: extended; IsFalse: extended): extended;
begin
  if What then
    Result := IsTrue
  else
    Result := IsFalse;
end;

function BoolToStr(Value: boolean): string;
begin
  if Value then
    Result := '1'
  else
    Result := '0';
end;

function StrToBool(Value: string): boolean;
begin
   if Value = '1' then
    Result := true
  else if Value = '0' then
    Result := false
  else if (Value = '-1') or (CompareText(Value, 'true') = 0)
    or (CompareText(Value, 'wahr') = 0)
    or (CompareText(Value, 'ja') = 0)
    or (CompareText(Value, 'yes') = 0) then
  begin
    Result := true
  end
  else if (CompareText(Value, 'false') = 0)
    or (CompareText(Value, 'falsch') = 0)
    or (CompareText(Value, 'nein') = 0)
    or (CompareText(Value, 'no') = 0) then
  begin
    Result := false;
  end
  else
    raise EConvertError('String "' + Value + '" kann nicht nach boolean konvertiert werden');
end;

function StrToBoolDef(Value: string; Def: boolean): boolean;
begin
  try
    Result := StrToBool(Value);
  except
    on EConvertError do
      Result := Def;
  end;
end;

function HexToInt(HexValue: string; Default: integer): integer;
var
  I: integer;
  a: char;
begin
  HexValue := UpperCase(trim(HexValue));
  if HexValue = '' then
    Result := Default
  else
  begin
    Result := 0;
    for I := 1 to Length(HexValue) do
    begin
      a := HexValue[I];
      if a in ['0'..'9'] then
        Result := Result * 16 + ord(a) - ord('0')
      else if a in ['A'..'F'] then
        Result := Result * 16 + ord(a) - ord('A') + 10
      else
      begin
        Result := Default;
        break;
      end;
    end;
  end;
end;

procedure Tausche(var v1, v2: byte);
var
  Puffer: integer;
begin
  Puffer := v1;
  v1 := v2;
  v2 := Puffer;
end;

procedure Tausche(var v1, v2: integer);
var
  Puffer: integer;
begin
  Puffer := v1;
  v1 := v2;
  v2 := Puffer;
end;

procedure Tausche(var v1, v2: extended); overload;
var
  Puffer: extended;
begin
  Puffer := v1;
  v1 := v2;
  v2 := Puffer;
end;

procedure Tausche(var v1, v2: string); overload;
var
  Puffer: string;
begin
  Puffer := v1;
  v1 := v2;
  v2 := Puffer;
end;

procedure KleinerGroesser(var v1, v2: byte); overload;
begin
  if v2 < v1 then
    Tausche(v1, v2);
end;

procedure KleinerGroesser(var v1, v2: integer);
begin
  if v2 < v1 then
    Tausche(v1, v2);
end;

procedure KleinerGroesser(var v1, v2: extended);
begin
  if v2 < v1 then
    Tausche(v1, v2);
end;

function GetKleiner(v1, v2: integer): integer;
begin
  if v1 < v2 then
    Result := v1
  else
    Result := v2;
end;

function GetKleiner(v1, v2: extended): extended;
begin
  if v1 < v2 then
    Result := v1
  else
    Result := v2;
end;

function GetGroesser(v1, v2: integer): integer;
begin
  if v1 < v2 then
    Result := V2
  else
    Result := v1;
end;

function GetGroesser(v1, v2: extended): extended;
begin
  if v1 < v2 then
    Result := V2
  else
    Result := v1;
end;

function CheckMinMax(var iVar: byte; iMin, iMax: byte): integer; overload;
begin
  Result := 0;
  KleinerGroesser(iMin, iMax);
  if iVar < iMin then
  begin
    iVar := iMin;
    Result := -1;
  end
  else if iVar > iMax then
  begin
    iVar := iMax;
    Result := 1;
  end;
end;

function CheckMinMax(var iVar: integer; iMin, iMax: integer): integer;
begin
  Result := 0;
  KleinerGroesser(iMin, iMax);
  if iVar < iMin then
  begin
    iVar := iMin;
    Result := -1;
  end
  else if iVar > iMax then
  begin
    iVar := iMax;
    Result := 1;
  end;
end;

function CheckMinMax(var iVar: extended; iMin, iMax: extended): integer; 
begin
  Result := 0;
  KleinerGroesser(iMin, iMax);
  if iVar < iMin then
  begin
    iVar := iMin;
    Result := -1;
  end
  else if iVar > iMax then
  begin
    iVar := iMax;
    Result := 1;
  end;
end;

function IsBetween(iValue, iMin, iMax: integer): boolean;
begin
  KleinerGroesser(iMin, iMax);
  Result := (iMin <= iValue) and (iValue <= iMax);
end;

function IsBetween(iValue, iMin, iMax: extended): boolean;
begin
  KleinerGroesser(iMin, iMax);
  Result := (iMin <= iValue) and (iValue <= iMax);
end;


procedure ToRaster(var X: extended; X0, XStep: extended);
var
  eTmp: extended;
  iTmp: integer;
begin
  eTmp := (X - X0) / XStep;
  iTmp := LowerInt(eTmp);
  if eTmp - iTmp >= 0.5 then
    inc(iTmp);

  X := iTmp * XStep + X0;
end;

procedure Drehe(var X,Y: integer; NX,NY: integer; Winkel: integer);
  function GradToRad(Grad: extended): extended;
  begin
    Result := Grad / 1800 * Pi;
  end;
var
  A,B, Rad: extended;
  lx, ly: integer;
begin
  Rad := GradToRad(Winkel);
  A := cos(Rad);
  B := sin(Rad);
  lx := X - NX;
  ly := Y - NY;
  X := round(A*lx-B*ly) + NX;
  Y := round(A*ly+B*lx) + NY;
end;

procedure Drehe(var X,Y: integer; Winkel: integer);
  function GradToRad(Grad: extended): extended;
  begin
    Result := Grad / 1800 * Pi;
  end;
var
  A,B, Rad: extended;
  lx, ly: integer;
begin
  Rad := GradToRad(Winkel);
  A := cos(Rad);
  B := sin(Rad);
  lx := X;
  ly := Y;
  X := round(A*lx-B*ly);
  Y := round(A*ly+B*lx);
end;

function LabelCaption(Caption: string): string;
var
  i: integer;
begin
  Result := '';
  for i := 1 to length(Caption) do
  begin
    if Caption[i] = '&' then
      Result := Result + '&';
    Result := Result + Caption[i];
  end;
end;

function ReplaceSubStr(Str, FindStr,ReplaceStr: string): string;
var
  i: integer;
  LenFind: integer;
begin
  Result := '';
  LenFind := length(FindStr);
  i := 1;
  while i <= length(Str) do
  begin
    if Copy(Str, i, LenFind) = FindStr then
    begin
      Result := Result + ReplaceStr;
      i := i + LenFind;
    end
    else
    begin
      Result := Result + Str[i];
      inc(i);
    end;
  end;
end;

function StrToSek(Str: string): word;
var
  Teil: string;
begin
  Result := 0;
  Teil := '';
  while (length(Str) > 0) and (Str[1] in ['0'..'9']) and (length(Teil) < 3) do
  begin
    Teil := Teil + Str[1];
    Str := Copy(Str, 2, length(Str) - 1);
  end;

  if Str = '' then
    Result := StrToIntDef(Teil, 0)
  else if (Str[1] = ':') and (Teil <> '') then
  begin
    Result := StrToInt(Teil) * 60;

    Str := Copy(Str, 2, length(Str) - 1);
    Teil := '';
    while (length(Str) > 0) and (Str[1] in ['0'..'9']) and (length(Teil) < 3) do
    begin
      Teil := Teil + Str[1];
      Str := Copy(Str, 2, length(Str) - 1);
    end;

    if (Str = '') and (Teil <> '') then
      Result := Result + StrToInt(Teil)
    else
      Result := 0;
  end;
end;

function StrToSQL(Str: string): string;
begin
  Result := ReplaceSubStr(Str, '''', '''''');
end;

procedure DotLine(Canvas: TCanvas; X1, Y1, X2, Y2: integer);
var
  X, Y, XYStep: integer;
  Grenze, Walker, Step: integer;
begin
  if abs(X1-X2) < abs(Y1-Y2) then
  begin
    Grenze := abs(Y1-Y2);
    Step := abs(X1-X2);
    Walker := Grenze div 2;
    X := X1;
    Y := Y1;

    if Y2 > Y1 then
      XYStep := 2
    else
      XYStep := -2;

    while (Y2 - Y) * XYStep >= 0 do
    begin
      Canvas.MoveTo(X, Y);
      Canvas.LineTo(X+1, Y);
      inc(Y, XYStep);
      inc(Walker, Step);
      if Walker > Grenze then
      begin
        dec(Walker, Grenze);
        inc(X);
      end;
    end;
  end
  else
  begin
    Grenze := abs(X1-X2);
    Step := abs(Y1-Y2);
    Walker := Grenze div 2;
    X := X1;
    Y := Y1;

    if X2 > X1 then
      XYStep := 2
    else
      XYStep := -2;

    while (X2 - X) * XYStep >= 0 do
    begin
      Canvas.MoveTo(X, Y);
      Canvas.LineTo(X+1, Y);
      inc(X, XYStep);
      inc(Walker, Step);
      if Walker > Grenze then
      begin
        dec(Walker, Grenze);
        inc(X);
      end;
    end;
  end;
end;

function ListAppend(AList: string; NewItem: string;
  Trennzeichen: char = ','): string;
begin
  if AList = '' then
    Result := NewItem
  else
    Result := AList + Trennzeichen + NewItem;
end;

function ListAppend(AList: string; NewItem: integer; Trennzeichen: char = ','): string;
begin
  Result := ListAppend(AList, IntTostr(NewItem), Trennzeichen);
end;

function ListLen(AList: string; Trennzeichen: string = ','): integer;
var
  i: integer;
begin
  Result := 1;
  for i := 1 to length(AList) do
  begin
    if Pos(AList[i], Trennzeichen) > 0 then
      inc(Result);
  end;
end;

procedure ListCharPos(AList: string; Idx: integer;
  out Found: boolean; out Start, Ende: integer; Trennzeichen: string = ',');
var
  ALen: integer;
begin
  ALen := length(AList);

  if Idx = 0 then
  begin
    Start := 1;
    Found := true;
  end
  else
  begin
    Start := 1;
    Found := false;
    while not Found and (Start <= ALen) do
    begin
      if Pos(AList[Start], Trennzeichen) > 0 then
      begin
        dec(Idx);
        Found := Idx = 0;
      end;
      inc(Start);
    end;
  end;

  if Found then
  begin
    Ende := Start;
    dec(Start);

    Found := false;
    while not Found and (Ende <= ALen) do
    begin
      Found := Pos(AList[Ende], Trennzeichen) > 0;
      inc(Ende);
    end;
    if Found then
      dec(Ende);

    Found := true;
  end;
end;

function ListGetAt(AList: string; Idx: integer; Trennzeichen: string = ','): string;
var
  Start, Ende: integer;
  Found: boolean;
begin
  ListCharPos(AList, Idx, Found, Start, Ende, Trennzeichen);
  if Found then
    Result := Copy(AList, Start+1, Ende-Start-1)
  else
    Result := ''
end;

function ListSetAt(AList: string; NewItem: string; Idx: integer; Trennzeichen: string = ','): string;
var
  Start, Ende: integer;
  Found: boolean;
begin
  ListCharPos(AList, Idx, Found, Start, Ende, Trennzeichen);
  if Found then
  begin
    if Start = 0 then
      Result := NewItem
    else
      Result := Left(AList, Start) + NewItem;

    if Ende <= length(AList) then
      Result := Result + CutLeft(AList, Ende - 1);
  end
  else
    Result := ''
end;

function ListDeleteAt(AList: string; Idx: integer; Trennzeichen: string = ','): string;
var
  Start, Ende: integer;
  Found: boolean;
begin
  ListCharPos(AList, Idx, Found, Start, Ende, Trennzeichen);
  if Found then
  begin
    if Ende > length(AList) then
    begin
      if Start = 0 then
        Result := ''
      else
        Result := Copy(AList, 1, Start - 1);
    end
    else
    begin
      if Start = 0 then
        Result := Right(AList, length(AList) - Ende)
      else
        Result := Left(AList, Start) + Right(AList, length(AList) - Ende);
    end;
  end
  else
    Result := AList;
end;

function ListFindNoCase(AList: string; Item: string; Trennzeichen: string = ','): integer;
var
  i: integer;
  Found: boolean;
  ALen: integer;
  Start: integer;
begin
  Result := 0;
  Found := false;
  i := 1;
  ALen := length(AList);
  Start := 1;
  while not Found and (i <= ALen) do
  begin
    if Pos(AList[i], Trennzeichen) > 0 then
    begin
      if CompareText(Item, Copy(AList, Start, i - Start)) = 0 then
        Found := true
      else
      begin
        inc(Result);
        Start := i + 1;
      end;
    end;
    inc(i);
  end;

  if not Found then
  begin
     if CompareText(Item, Copy(AList, Start, i - Start)) <> 0 then
      Result := -1;
  end;
end;

function ListSchnittmenge(List1, List2: string; Trennzeichen: string = ','): string;
var
  i: integer;
  ALen: integer;
  APos: integer;
  Item: string;
begin
  Result := '';
  ALen := ListLen(List1, Trennzeichen);
  for i :=  0 to ALen - 1 do
  begin
    Item := ListGetAt(List1, i, Trennzeichen);
    APos := ListFindNoCase(List2, Item);
    if APos >= 0 then
      Result := ListAppend(Result, Item);
  end;
end;

procedure ListToTStrings(List: string; Strings: TStrings; Trennzeichen: string);
var
  i: integer;
  ALen: integer;
  Start: integer;
begin
  Strings.Clear;
  i := 1;
  ALen := length(List);
  Start := 1;
  while i <= ALen do
  begin
    if Pos(List[i], Trennzeichen) > 0 then
    begin
      Strings.Add(Copy(List, Start, i-Start));
      Start := i + 1;
    end;
    inc(i);
  end;
  if Start <= length(List) then
    Strings.Add(Copy(List, Start, i-Start));
end;

function ListToNewTStringList(List: string; Trennzeichen: string): TStringList;
begin
  Result := TStringList.Create;
  ListToTStrings(List, Result, Trennzeichen);
end;

function ListFromTStrings(Strings: TStrings; Trennzeichen: char): string;
var
  i: integer;
  Trenner: string;
begin
  Result := '';
  Trenner := '';
  for i := 0 to Strings.Count - 1 do
  begin
    Result :=  Result + Trenner + Strings[i];
    Trenner := Trennzeichen;
  end;
end;

function ClassHierarchyAsList(ClassType: TClass; UntilClass: TClass = nil; Trennzeichen: char = ','): string;
var
  Trenner: string;
begin
  Result := '';
  Trenner := '';
  while (ClassType <> nil) and (ClassType <> UntilClass) do
  begin
    Result := Result + Trenner + ClassType.ClassName;
    Trenner := Trennzeichen;
    ClassType := ClassType.ClassParent;
  end;
end;

function ExtLine(X1, Y1, X2, Y2: extended): TExtLine;
begin
  Result.X1 := X1;
  Result.Y1 := Y1;
  Result.X2 := X2;
  Result.Y2 := Y2;
end;

function ExtLine(Point1, Point2: TExtPoint): TExtLine;
begin
  Result.X1 := Point1.X;
  Result.Y1 := Point1.Y;
  Result.X2 := Point2.X;
  Result.Y2 := Point2.Y;
end;

function ExtPoint(X, Y: extended): TExtPoint;
begin
  Result.X := X;
  Result.Y := Y;
end;

function ExtPointsEqual(p1, p2: TExtPoint): boolean;
begin
  Result := FloatEqual(p1.X, p2.X) and FloatEqual(p1.Y, p2.Y);
end;

function CenterPoint(p1, p2: TExtPoint): TExtPoint;
begin
	Result := ExtPoint((p1.X +p2.X) / 2, (p1.Y +p2.Y) / 2);
end;

function CenterPoint(p1, p2: TPoint): TPoint;
begin
	Result := Point((p1.X +p2.X) div 2, (p1.Y +p2.Y) div 2);
end;

function FloatEqual(e1, e2: extended): boolean;
begin
  Result := abs(e1-e2) < 1e-9;
end;

function FloatLessEqual(e1, e2: extended): boolean;
begin
  Result := FloatEqual(e1, e2) or (e1 < e2);
end;

function FloatLess(e1, e2: extended): boolean;
begin
  Result := not FloatEqual(e1, e2) and (e1 < e2);
end;

function FloatGreaterEqual(e1, e2: extended): boolean;
begin
  Result := FloatEqual(e1, e2) or (e1 > e2);
end;

function FloatGreater(e1, e2: extended): boolean;
begin
  Result := not FloatEqual(e1, e2) and (e1 > e2);
end;

function ExtBounds(Left, Top, Width, Height: extended): TExtRect;
begin
  Result.Left := Left;
  Result.Top := Top;
  Result.Right := Left + Width;
  Result.Bottom := Top + Height;
end;

function ExtRect(Left, Top, Right, Bottom: extended): TExtRect;
begin
  Result.Left := Left;
  Result.Top := Top;
  Result.Right := Right;
  Result.Bottom := Bottom;
end;

function ExtRect(ARect: TRect): TExtRect;
begin
  Result.Left := ARect.Left;
  Result.Top := ARect.Top;
  Result.Right := ARect.Right;
  Result.Bottom := ARect.Bottom;
end;

function RoundRect(ARect: TExtRect): TRect;
begin
  Result.Left := round(ARect.Left);
  Result.Top := round(ARect.Top);
  Result.Right := round(ARect.Right);
  Result.Bottom := round(ARect.Bottom);
end;


function NormalizeRect(const ARect: TRect): TRect;
begin
  Result := ARect;
  if Result.Left > Result.Right then
    Tausche(Result.Left, Result.Right);
  if Result.Top > Result.Bottom then
    Tausche(Result.Top, Result.Bottom);
end;

function NormalizeRect(const ARect: TExtRect): TExtRect;
begin
  Result := ARect;
  if Result.Left > Result.Right then
    Tausche(Result.Left, Result.Right);
  if Result.Top > Result.Bottom then
    Tausche(Result.Top, Result.Bottom);
end;

procedure CheckPaintRect(var ARect: TRect);
begin
  ARect := NormalizeRect(ARect);
  if ARect.Left = ARect.Right then
    inc(ARect.Right);
  if ARect.Top = ARect.Bottom then
    inc(ARect.Bottom);
end;

function AlignRect(const OrgRect, BorderRect: TRect;
  HorzAlign: THorzAlign; VertAlign: TVertAlign): TRect;
var
  bRect: TRect;
  Offset: integer;
begin
  Result:= NormalizeRect(OrgRect);
  bRect:= NormalizeRect(BorderRect);

  case HorzAlign of
  haLeft:
    begin
      Result.Right := Result.Right - Result.Left + bRect.Left;
      Result.Left := bRect.Left;
    end;
  haCenter:
    begin
      Offset := (bRect.Right + bRect.Left - Result.Right - Result.Left) div 2;
      Result.Left := Result.Left + Offset;
      Result.Right := Result.Right + Offset;
    end;
  haRight:
    begin
      Result.Left := Result.Left - Result.Right + bRect.Right;
      Result.Right := bRect.Right;
    end;
  end;

  case VertAlign of
  vaTop:
    begin
      Result.Bottom := Result.Bottom - Result.Top + bRect.Top;
      Result.Top := bRect.Top;
    end;
  vaCenter:
    begin
      Offset := (bRect.Bottom + bRect.Top - Result.Bottom - Result.Top) div 2;
      Result.Top := Result.Top + Offset;
      Result.Bottom := Result.Bottom + Offset;
    end;
  vaBottom:
    begin
      Result.Top := Result.Top - Result.Bottom + bRect.Bottom;
      Result.Bottom := bRect.Bottom;
    end;
  end;
end;

function AlignRect(const OrgRect, BorderRect: TExtRect;
  HorzAlign: THorzAlign; VertAlign: TVertAlign): TExtRect;
var
  bRect: TExtRect;
  Offset: extended;
begin
  Result:= NormalizeRect(OrgRect);
  bRect:= NormalizeRect(BorderRect);

  case HorzAlign of
  haLeft:
    begin
      Result.Right := Result.Right - Result.Left + bRect.Left;
      Result.Left := bRect.Left;
    end;
  haCenter:
    begin
      Offset := (bRect.Right + bRect.Left - Result.Right - Result.Left) / 2;
      Result.Left := Result.Left + Offset;
      Result.Right := Result.Right + Offset;
    end;
  haRight:
    begin
      Result.Left := Result.Left - Result.Right + bRect.Right;
      Result.Right := bRect.Right;
    end;
  end;

  case VertAlign of
  vaTop:
    begin
      Result.Bottom := Result.Bottom - Result.Top + bRect.Top;
      Result.Top := bRect.Top;
    end;
  vaCenter:
    begin
      Offset := (bRect.Bottom + bRect.Top - Result.Bottom - Result.Top) / 2;
      Result.Top := Result.Top + Offset;
      Result.Bottom := Result.Bottom + Offset;
    end;
  vaBottom:
    begin
      Result.Top := Result.Top - Result.Bottom + bRect.Bottom;
      Result.Bottom := bRect.Bottom;
    end;
  end;
end;


procedure FitRect(var Width, Height: integer; BorderWidth, BorderHeight: integer);
begin
  if (Width = 0) and (Height = 0) then
  begin
    Width := BorderWidth;
    Height := BorderHeight;
  end
  else if Width = 0 then
    Height := BorderHeight
  else if Height = 0 then
    Width := BorderWidth
  else if (BorderWidth = 0) or (BorderHeight = 0) then
  begin
    Width := 0;
    Height := 0;
  end
  else
  begin
    if Width / Height > BorderWidth / BorderHeight  then
    begin
      Height := round(BorderWidth / Width * Height);
      Width := BorderWidth;
    end
    else
    begin
      Width := round(BorderHeight / Height * Width);
      Height := BorderHeight;
    end;
  end;
end;

procedure FitRect(var Width, Height: extended; BorderWidth, BorderHeight: extended);
begin
  if (Width = 0) and (Height = 0) then
  begin
    Width := BorderWidth;
    Height := BorderHeight;
  end
  else if Width = 0 then
    Height := BorderHeight
  else if Height = 0 then
    Width := BorderWidth
  else if (BorderWidth = 0) or (BorderHeight = 0) then
  begin
    Width := 0;
    Height := 0;
  end
  else
  begin
    if abs(Width / Height) > abs(BorderWidth / BorderHeight)  then
    begin
      Height := abs(BorderWidth / Width * Height);
      if BorderHeight < 0 then
        Height := -Height;
      Width := BorderWidth;
    end
    else
    begin
      Width := abs(BorderHeight / Height * Width);
      if BorderWidth < 0 then
        Width := -Width;
      Height := BorderHeight;
    end;
  end;
end;

function FitRect(const OrgRect, BorderRect: TRect;
  HorzAlign: THorzAlign; VertAlign: TVertAlign): TRect;
var
  OrgWidth, OrgHeight: integer;
  BorderWidth, BorderHeight: integer;
begin
  OrgWidth := abs(OrgRect.Right - OrgRect.Left);
  OrgHeight := abs(OrgRect.Bottom- OrgRect.Top);
  BorderWidth := abs(BorderRect.Right - BorderRect.Left);
  BorderHeight := abs(BorderRect.Bottom- BorderRect.Top);

  FitRect(OrgWidth, OrgHeight, BorderWidth, BorderHeight);
  Result := AlignRect(Bounds(OrgRect.Left, OrgRect.Top, OrgWidth, OrgHeight),
    Bounds(BorderRect.Left, BorderRect.Top, BorderWidth, BorderHeight),
    HorzAlign, VertAlign);
end;

function FitRect(const OrgRect, BorderRect: TExtRect;
  HorzAlign: THorzAlign = haCenter; VertAlign: TVertAlign = vaCenter): TExtRect;
var
  OrgWidth, OrgHeight: extended;
  BorderWidth, BorderHeight: extended;
begin
  OrgWidth := abs(OrgRect.Right - OrgRect.Left);
  OrgHeight := abs(OrgRect.Bottom- OrgRect.Top);
  BorderWidth := abs(BorderRect.Right - BorderRect.Left);
  BorderHeight := abs(BorderRect.Bottom- BorderRect.Top);

  FitRect(OrgWidth, OrgHeight, BorderWidth, BorderHeight);

  Result := AlignRect(ExtBounds(OrgRect.Left, OrgRect.Top, OrgWidth, OrgHeight),
    ExtBounds(BorderRect.Left, BorderRect.Top, BorderWidth, BorderHeight),
    HorzAlign, VertAlign);
end;

function FitRect(const OrgRect, BorderRect: TRect; XAnker, YAnker: integer): TRect;
var
  MerkWidth, MerkHeight: integer;
  OrgWidth, OrgHeight: integer;
  BorderWidth, BorderHeight: integer;
begin
  OrgWidth := abs(OrgRect.Right - OrgRect.Left);
  OrgHeight := abs(OrgRect.Bottom- OrgRect.Top);
  if (OrgWidth = 0) or (OrgHeight = 0) then
    raise EDivByZero.Create('FitRect: Das Rechteck OrgRect muss eine Flche haben');
  BorderWidth := BorderRect.Right - BorderRect.Left;
  BorderHeight := BorderRect.Bottom- BorderRect.Top;

  MerkWidth := OrgWidth;
  MerkHeight := OrgHeight;

  FitRect(OrgWidth, OrgHeight, BorderWidth, BorderHeight);

  if (abs(XAnker - OrgRect.Left) < abs(XAnker - OrgRect.Right)) then
  begin
    Result.Left := XAnker - round((XAnker - OrgRect.Left) / MerkWidth * OrgWidth);
    Result.Right := Result.Left + OrgWidth;
  end
  else
  begin
    Result.Right := XAnker - round((XAnker - OrgRect.Right) / MerkWidth * OrgWidth);
    Result.Left := Result.Right - OrgWidth;
  end;

  if (abs(YAnker - OrgRect.Top) < abs(YAnker - OrgRect.Bottom)) then
  begin
    Result.Top := YAnker - round((YAnker - OrgRect.Top) / MerkHeight * OrgHeight);
    Result.Bottom := Result.Top + OrgHeight;
  end
  else
  begin
    Result.Bottom := YAnker - round((YAnker - OrgRect.Bottom) / MerkHeight * OrgHeight);
    Result.Top := Result.Bottom - OrgHeight;
  end;
  Result := NormalizeRect(Result);
end;

function FitRect(const OrgRect, BorderRect: TExtRect; XAnker, YAnker: extended): TExtRect;
var
  MerkWidth, MerkHeight: extended;
  OrgWidth, OrgHeight: extended;
  BorderWidth, BorderHeight: extended;
begin
  OrgWidth := abs(OrgRect.Right - OrgRect.Left);
  OrgHeight := abs(OrgRect.Bottom - OrgRect.Top);
  if (OrgWidth = 0) or (OrgHeight = 0) then
    raise EDivByZero.Create('FitRect: Das Rechteck OrgRect muss eine Flche haben');
  BorderWidth := BorderRect.Right - BorderRect.Left;
  BorderHeight := BorderRect.Bottom - BorderRect.Top;
  MerkWidth := OrgWidth;
  MerkHeight := OrgHeight;

  FitRect(OrgWidth, OrgHeight, BorderWidth, BorderHeight);

  if (abs(XAnker - OrgRect.Left) < abs(XAnker - OrgRect.Right)) then
  begin
    Result.Left := XAnker - (XAnker - OrgRect.Left) / MerkWidth * OrgWidth;
    Result.Right := Result.Left + OrgWidth;
  end
  else
  begin
    Result.Right := XAnker - (XAnker - OrgRect.Right) / MerkWidth * OrgWidth;
    Result.Left := Result.Right - OrgWidth;
  end;

  if MerkHeight = 0 then
  begin
    Result.Top := OrgRect.Top;
    Result.Bottom := Result.Top;
  end
  else
  begin
    if (abs(YAnker - OrgRect.Top) < abs(YAnker - OrgRect.Bottom)) then
    begin
      Result.Top := YAnker - (YAnker - OrgRect.Top) / MerkHeight * OrgHeight;
      Result.Bottom := Result.Top + OrgHeight;
    end
    else
    begin
      Result.Bottom := YAnker - (YAnker - OrgRect.Bottom) / MerkHeight * OrgHeight;
      Result.Top := Result.Bottom - OrgHeight;
    end;
  end;

  Result := NormalizeRect(Result);
end;

function FitRect(AlignCorner: TCorner; const OrgRect: TExtRect; BorderWidth, BorderHeight: extended): TExtRect;
var
  OrgWidth, OrgHeight: extended;
begin
  OrgWidth := OrgRect.Right - OrgRect.Left;
  OrgHeight := OrgRect.Bottom - OrgRect.Top;

  FitRect(OrgWidth, OrgHeight, BorderWidth, BorderHeight);

  Result := OrgRect;
  case AlignCorner of
  cTopLeft:
    begin
      Result.Right := Result.Left + OrgWidth;
      Result.Bottom := Result.Top + OrgHeight;
    end;
  cTopRight:
    begin
      Result.Left := Result.Right - OrgWidth;
      Result.Bottom := Result.Top + OrgHeight;
    end;
  cBottomRight:
    begin
      Result.Left := Result.Right - OrgWidth;
      Result.Top := Result.Bottom - OrgHeight;
    end;
  cBottomLeft:
    begin
      Result.Right := Result.Left + OrgWidth;
      Result.Top := Result.Bottom - OrgHeight;
    end;
  end;
end;



function InRect(X,Y: integer; ARect: TRect): boolean;
begin
  ARect := NormalizeRect(ARect);
  Result := (ARect.Left <= X) and (X <= ARect.Right)
    and (ARect.Top <= Y) and (Y <= ARect.Bottom);
end;

function InGraphicRect(X,Y: integer; ARect: TRect): boolean;
begin
  ARect := NormalizeRect(ARect);
  Result := (ARect.Left <= X) and (X < ARect.Right)
    and (ARect.Top <= Y) and (Y < ARect.Bottom);
end;

function InGraphicRect(X,Y: extended; ARect: TExtRect): boolean;
begin
  ARect := NormalizeRect(ARect);
  Result := FloatLessEqual(ARect.Left,  X) and FloatLess(X, ARect.Right)
    and FloatLessEqual(ARect.Top, Y) and FloatLess(Y, ARect.Bottom);
end;

function InGraphicRect(APoint: TExtPoint; ARect: TExtRect): boolean;
begin
  Result := InGraphicRect(APoint.X, APoint.Y, ARect);
end;

function InGraphicRect(IsRect, InRect: TRect): boolean;
begin
  IsRect := NormalizeRect(IsRect);
  InRect := NormalizeRect(InRect);
  Result := (InRect.Left <= IsRect.Left) and (IsRect.Right <= InRect.Right)
            and
            (InRect.Top <= IsRect.Top) and (IsRect.Bottom <= InRect.Bottom);
end;

function InGraphicRect(IsRect, InRect: TExtRect): boolean;
begin
  IsRect := NormalizeRect(IsRect);
  InRect := NormalizeRect(InRect);
  Result := FloatLessEqual(InRect.Left, IsRect.Left)
   					and FloatLessEqual(IsRect.Right, InRect.Right)
            and FloatLessEqual(InRect.Top, IsRect.Top)
            and FloatLessEqual(IsRect.Bottom, InRect.Bottom);
end;

function TouchGraphicRects(Rect1, Rect2: TRect): boolean;
begin
  Rect1 := NormalizeRect(Rect1);
  Rect2 := NormalizeRect(Rect2);
  Result := (  ((Rect1.Left <= Rect2.Left) and (Rect2.Left < Rect1.Right))
              or
              ((Rect2.Left <= Rect1.Left) and (Rect1.Left < Rect2.Right))
            )
            and
            (  ((Rect1.Top <= Rect2.Top) and (Rect2.Top < Rect1.Bottom))
              or
              ((Rect2.Top <= Rect1.Top) and (Rect1.Top < Rect2.Bottom))
            )
end;

function WinkelOfPoint(Point: TExtPoint): extended;
begin
  if FloatEqual(Point.X, 0) then
  begin
    if FloatEqual(Point.Y, 0) then
      Result := 0
    else if Point.Y > 0 then
      Result := pi/2
    else
      Result := -pi/2;
  end
  else
  begin
    Result := arctan(Point.Y / Point.X);
    if Point.X < 0 then
    begin
      if Result > 0 then
      	Result := Result - pi
      else if Result <= 0 then
      	Result := Result + pi;
    end;
  end;
end;

function NormWinkel(Winkel: extended): extended;
begin
  Result := Winkel;
  if Result < 0 then
  begin
    while Result < -pi do
      Result := Result + pi * 2;
  end
  else
  begin
    while Result > pi do
      Result := Result - pi * 2;
  end;
end;

procedure AnalizeLinePoint(Line: TExtLine; Point: TExtPoint; var Result: TAnalizeLinePointResult);
var
  LenX, LenY: extended;
  WinkelL, WinkelP: extended;
  pAbs, lAbs: extended;
begin
   LenX := Line.X2 - Line.X1;
  if FloatEqual(Point.Y * LenX, Line.Y1 * LenX + (Line.Y2 -Line.Y1) * (Point.X -Line.X1)) then
  begin // Wenn der Punkt auf der Linie liegt, zumindest, wenn man die Linie unendlich verlngern wrde
    if FloatEqual(LenX, 0) then
    begin // Wenn die Linie senkrecht steht
       LenY := Line.Y2 - Line.Y1;
      if FloatEqual(LenY, 0) then
      begin // Wenn die Linie in Wirklichkeit nur ein Punkt ist
        Result.Abstand := sqrt(sqr(Point.X - Line.X1) + sqr(Point.Y - Line.Y1));
        Result.Faktor := 0;
        Result.Winkel := pi;
        if FloatEqual(Result.Abstand, 0) then
          Result.State := alprsPointTouch
        else
          Result.State := alprsPointNoTouch;
      end
      else
      begin // Wenn die Linie wirklich eine Linie ist
        Result.Faktor := (Point.Y - Line.Y1) / LenY;
        Result.State := alprsTouchIn;
      end;
    end
    else
    begin // Wenn die Linie nicht senkrecht steht
      Result.Faktor := (Point.X - Line.X1) / LenX;
      Result.State := alprsTouchIn;
    end;

    if Result.State = alprsTouchIn then
    begin // Wenn der Result.State noch genau bestimmt werden muss
      if FloatEqual(Result.Faktor, 0) then
      begin
        Result.Faktor := 0;
        Result.State := alprsStart;
      end
      else if FloatEqual(Result.Faktor, 1) then
      begin
        Result.Faktor := 1;
        Result.State := alprsEnd;
      end
      else if (Result.Faktor > 1) or (Result.Faktor < 0) then
        Result.State := alprsTouchOut
      else
        Result.State := alprsTouchIn;

      if Result.Faktor < 0 then
        Result.Winkel := -pi
      else
        Result.Winkel := pi;
    end;
  end
  else
  begin // Wenn der Punkt nicht auf der Linie liegt
    LenY := Line.Y2 - Line.Y1;
    WinkelL := WinkelOfPoint(ExtPoint(LenX, LenY));
    WinkelP := WinkelOfPoint(ExtPoint(Point.X - Line.X1, Point.Y - Line.Y1));
    Result.Winkel := NormWinkel(WinkelL - WinkelP);
    if FloatEqual(abs(Result.Winkel), pi / 2) then
    begin // Wenn der Punkt senkrecht ber dem Startpunkt der Linie steht
      Result.Faktor := 0;
      Result.Abstand := sqrt(sqr(Point.X - Line.X1) + sqr(Point.Y - Line.Y1));
    end
    else
    begin
      pAbs := sqrt(sqr(Point.X - Line.X1) + sqr(Point.Y - Line.Y1));
      Result.Abstand := abs(sin(Result.Winkel) * pAbs);
      lAbs := sqrt(sqr(pAbs) - sqr(Result.Abstand));
      Result.Faktor := lAbs / sqrt(sqr(LenX) + sqr(LenY));
      if (Result.Winkel > pi/2) or (Result.Winkel < - pi/2) then
        Result.Faktor := -Result.Faktor;
    end;
    Result.State := alprsNoTouch;
  end;

  // Sicherstellen, dass Abstand wirklich Null ist, wenn State behauptet, dass sich der Punkt auf der Linie befindet
  Result.IsTouching := not(Result.State in [alprsNoTouch, alprsPointNoTouch]);
  Result.IsTouchingInside := Result.State in [alprsPointTouch, alprsTouchIn, alprsStart, alprsEnd];
  if Result.IsTouching then
    Result.Abstand := 0;
end;

procedure AnalizeLineLine(Line1, Line2: TExtLine; var Result: TAnalizeLineLineResult);
var
  Len1Y, Len2Y, Len1X, Len2X: extended;
  Term1, Term2: extended;
  X, Y: extended;
  lclPointResult: TAnalizeLinePointResult;
begin
  Result.LinesAreParallel := false;
  Len1Y := Line1.Y2 - Line1.Y1;
  Len2Y := Line2.Y2 - Line2.Y1;
  Len1X := Line1.X2 - Line1.X1;
  Len2X := Line2.X2 - Line2.X1;
  if FloatEqual(Len1Y, 0) or FloatEqual(Len2Y, 0) then
  begin // Wenn eine der beiden Linien waagerecht steht
    if FloatEqual(Len1X, 0) or FloatEqual(Len2X, 0) then
    begin // Wenn eine der beiden Linien senkrecht steht
       if (FloatEqual(Len1X, 0) and FloatEqual(Len1Y, 0)) or (FloatEqual(Len2X, 0) and FloatEqual(Len2Y, 0)) then
      begin // Wenn mindestens eine der beiden Linien in Wirklichkeit ein Punkt ist
        Result.LinesAreParallel := false;
        if FloatEqual(Len1X, 0) and FloatEqual(Len1Y, 0) then
        begin // Wenn die erste Linie ein Punkt ist
          Result.Point := ExtPoint(Line1.X1, Line1.Y1);
          AnalizeLinePoint(Line2, Result.Point, Result.Line2Data);
          Result.IsTouching := Result.Line2Data.IsTouching;
          Result.Line1Data.IsTouching := Result.Line2Data.IsTouching;
          Result.Line1Data.IsTouchingInside := Result.Line2Data.IsTouchingInside;
          Result.Abstand := Result.Line2Data.Abstand;
          Result.Line1Data.Abstand := Result.Line2Data.Abstand;
          if Result.IsTouching then
            Result.Line1Data.State := alprsPointTouch
          else
            Result.Line1Data.State := alprsPointNoTouch;
        end
        else
        begin // Wenn die zweite Linie ein Punkt ist
          Result.Point := ExtPoint(Line2.X1, Line2.Y1);
          AnalizeLinePoint(Line1, Result.Point, Result.Line1Data);
          Result.IsTouching := Result.Line1Data.IsTouching;
          Result.Line2Data.IsTouching := Result.Line1Data.IsTouching;
          Result.Line2Data.IsTouchingInside := Result.Line1Data.IsTouchingInside;
          Result.Abstand := Result.Line1Data.Abstand;
          Result.Line2Data.Abstand := Result.Line1Data.Abstand;
          if Result.IsTouching then
            Result.Line2Data.State := alprsPointTouch
          else
            Result.Line2Data.State := alprsPointNoTouch;
        end
      end
      else
      begin // Wenn tatschlich eine Linie senkrecht und eine waagerecht steht
        if FloatEqual(Len1X, 0) then
          Result.Point := ExtPoint(Line1.X1, Line2.Y1)
        else
          Result.Point := ExtPoint(Line2.X1, Line1.Y1);

        AnalizeLinePoint(Line1, Result.Point, Result.Line1Data);
        AnalizeLinePoint(Line2, Result.Point, Result.Line2Data);

        Result.IsTouching := Result.Line1Data.IsTouching;
      end;
    end
    else
    begin // Wenn keine der beiden Linien senkrecht steht
      Term1 := Len1Y / Len1X;
      Term2 := Len2Y / Len2X;
      if FloatEqual(Term1, Term2) then
      begin // Wenn die beiden Linien zueinander parallel stehen
        Result.IsTouching := false;
        Result.LinesAreParallel := true;
        AnalizeLinePoint(Line1, ExtPoint(Line2.X1, Line2.Y1), lclPointResult);
        Result.Abstand := lclPointResult.Abstand;
      end
      else
      begin // Wenn beide Linien nicht zueinander parallel stehen
        X := (Line2.Y1 - Line1.Y1 - Term2 * Line2.X1 + Term1 * Line1.X1) / (Term1 - Term2);
        Y := Line1.Y1 + Len1Y * (X - Line1.X1) / Len1X;
        Result.Point := ExtPoint(X, Y);

        AnalizeLinePoint(Line1, Result.Point, Result.Line1Data);
        AnalizeLinePoint(Line2, Result.Point, Result.Line2Data);
        Result.IsTouching := Result.Line1Data.IsTouching;
      end;
    end;
  end
  else
  begin // Wenn keine der beiden Linien waagerecht steht
    Term1 := Len1X / Len1Y;
    Term2 := Len2X / Len2Y;
    if FloatEqual(Term1, Term2) then
    begin // Wenn die beiden Linien zueinander parallel stehen
      Result.IsTouching := false;
      Result.LinesAreParallel := true;
      AnalizeLinePoint(Line1, ExtPoint(Line2.X1, Line2.Y1), lclPointResult);
      Result.Abstand := lclPointResult.Abstand;
    end
    else
    begin // Wenn beide Linien nicht zueinander parallel stehen
      Y := (Line2.X1 - Line1.X1 - Term2 * Line2.Y1 + Term1 * Line1.Y1) / (Term1 - Term2);
      X := Line1.X1 + Len1X * (Y - Line1.Y1) / Len1Y;
      Result.Point := ExtPoint(X, Y);

      AnalizeLinePoint(Line1, Result.Point, Result.Line1Data);
      AnalizeLinePoint(Line2, Result.Point, Result.Line2Data);
      Result.IsTouching := Result.Line1Data.IsTouching;
    end;
  end;
end;

procedure AnalizeLineRect(Line: TExtLine; Rect: TExtRect; var Result: TAnalizeLineRectResult);
var
  allr: TAnalizeLineLineResult;
  StepOver2, StepOver3, StepOver4: boolean;
  RectLine: TExtLine;
  LineCounter: integer;
  lclCutPoint: TRakLineCutPoint;
begin
  Rect := NormalizeRect(Rect);

  Result.CutPoint1.State := lcpsNone;
  Result.CutPoint2.State := lcpsNone;

  StepOver2 := false;
  StepOver3 := false;
  StepOver4 := false;
  LineCounter := 0;
  RectLine := ExtLine(Rect.Left, Rect.Top, Rect.Right, Rect.Top);
  AnalizeLineLine(Line, RectLine, allr);
  if not allr.LinesAreParallel and allr.Line2Data.IsTouchingInside then
  begin
    lclCutPoint.Point := allr.Point;
    if allr.Line1Data.State = alprsTouchOut then
      lclCutPoint.State := lcpsOut
    else if allr.Line1Data.State = alprsPointTouch then
      lclCutPoint.State := lcpsPoint
    else if allr.Line1Data.State = alprsStart then
      lclCutPoint.State := lcpsLineStart
    else if allr.Line1Data.State = alprsEnd then
      lclCutPoint.State := lcpsLineEnd
    else
      lclCutPoint.State := lcpsIn;

    Result.CutPoint1 := lclCutPoint;
    inc(LineCounter);
    StepOver2 := allr.Line2Data.State = alprsEnd;
    StepOver4 := allr.Line2Data.State = alprsStart;
  end;

  if not StepOver2 then
  begin
    RectLine := ExtLine(Rect.Right, Rect.Top, Rect.Right, Rect.Bottom);
    AnalizeLineLine(Line, RectLine, allr);
    if not allr.LinesAreParallel and allr.Line2Data.IsTouchingInside then
    begin
      lclCutPoint.Point := allr.Point;
      if allr.Line1Data.State = alprsTouchOut then
        lclCutPoint.State := lcpsOut
      else if allr.Line1Data.State = alprsPointTouch then
        lclCutPoint.State := lcpsPoint
      else if allr.Line1Data.State = alprsStart then
        lclCutPoint.State := lcpsLineStart
      else if allr.Line1Data.State = alprsEnd then
        lclCutPoint.State := lcpsLineEnd
      else
        lclCutPoint.State := lcpsIn;

      inc(LineCounter);
      if LineCounter = 2 then
      begin
        Result.CutPoint2 := lclCutPoint;
        StepOver3 := true;
        StepOver4 := true;
      end
      else
      begin
        Result.CutPoint1 := lclCutPoint;
        StepOver3 := allr.Line2Data.State = alprsEnd;
      end;
    end;
  end;

  if not StepOver3 then
  begin
    RectLine := ExtLine(Rect.Left, Rect.Bottom, Rect.Right, Rect.Bottom);
    AnalizeLineLine(Line, RectLine, allr);
    if not allr.LinesAreParallel and allr.Line2Data.IsTouchingInside then
    begin
      lclCutPoint.Point := allr.Point;
      if allr.Line1Data.State = alprsTouchOut then
        lclCutPoint.State := lcpsOut
      else if allr.Line1Data.State = alprsPointTouch then
        lclCutPoint.State := lcpsPoint
      else if allr.Line1Data.State = alprsStart then
        lclCutPoint.State := lcpsLineStart
      else if allr.Line1Data.State = alprsEnd then
        lclCutPoint.State := lcpsLineEnd
      else
        lclCutPoint.State := lcpsIn;

      inc(LineCounter);
      if LineCounter = 2 then
      begin
        Result.CutPoint2 := lclCutPoint;
        StepOver4 := true;
      end
      else
      begin
        Result.CutPoint1 := lclCutPoint;
        StepOver4 := allr.Line2Data.State = alprsEnd;
      end;
    end;
  end;

  if not StepOver4 then
  begin
    RectLine := ExtLine(Rect.Left, Rect.Top, Rect.Left, Rect.Bottom);
    AnalizeLineLine(Line, RectLine, allr);
    if not allr.LinesAreParallel and allr.Line2Data.IsTouchingInside then
    begin
      lclCutPoint.Point := allr.Point;
      if allr.Line1Data.State = alprsTouchOut then
        lclCutPoint.State := lcpsOut
      else if allr.Line1Data.State = alprsPointTouch then
        lclCutPoint.State := lcpsPoint
      else if allr.Line1Data.State = alprsStart then
        lclCutPoint.State := lcpsLineStart
      else if allr.Line1Data.State = alprsEnd then
        lclCutPoint.State := lcpsLineEnd
      else
        lclCutPoint.State := lcpsIn;

      inc(LineCounter);
      if LineCounter = 2 then
        Result.CutPoint2 := lclCutPoint
      else
        Result.CutPoint1 := lclCutPoint;
    end;
  end;

  if LineCounter = 0 then
    Result.State := alrrsOut
  else if InGraphicRect(Line.X1, Line.Y1, Rect) and InGraphicRect(Line.X2, Line.Y2, Rect) then
    Result.State := alrrsIn
  else if LineCounter = 2 then
  begin
    if (Result.CutPoint1.State = lcpsOut) and (Result.CutPoint2.State = lcpsOut) then
      Result.State := alrrsOut
    else
      Result.State := alrrsCut
  end
  else if Result.CutPoint1.State = lcpsOut then
    Result.State := alrrsOut
  else
    Result.State := alrrsTouch;
end;


procedure OffsetExtRect(var ARect: TExtRect; XOff, YOff: extended);
begin
  ARect.Left := ARect.Left + XOff;
  ARect.Right := ARect.Right + XOff;
  ARect.Top := ARect.Top + YOff;
  ARect.Bottom := ARect.Bottom + YOff;
end;

procedure GrowExtRect(var ARect: TExtRect; Off: extended);
begin
  ARect.Left := ARect.Left - Off;
  ARect.Right := ARect.Right + Off;
  ARect.Top := ARect.Top - Off;
  ARect.Bottom := ARect.Bottom + Off;
end;

function CutLeft(const str: string; Count: integer): string;
begin
  Result := '';
  if Count < length(str) then
    Result := Copy(str, Count + 1, length(str));
end;

function CutRight(const str: string; Count: integer): string;
begin
  if Count > 0 then
  begin
    if Count > length(str) then
      Result := ''
    else
    begin
      Result := str;
      SetLength(Result, length(Result) - Count);
    end;
  end
  else
    Result := str;
end;

function Left(const str: string; Count: integer): string;
begin
  Result := Copy(str, 1, Count);
end;

function Right(const str: string; Count: integer): string;
var
  Start: integer;
begin
  Start := length(str) - Count + 1;
  if Start < 1 then
    Start := 1;
  Result := Copy(str, Start, Count);
end;

function PosRight(Substr, S: string; StartIdx: integer): integer;
var
  i: integer;
  Len: integer;
begin
  Result := 0;

  Len := length(SubStr);
  if (StartIdx < 1) or (StartIdx > length(S) - Len + 1) then
    i := length(S) - Len + 1
  else
    i := StartIdx;

  while (Result = 0) and (i > 0) do
  begin
    if Copy(S, i, Len) = Substr then
      Result := i;
    dec(i);
  end;
end;

function PosRight(Zeichenmenge: TZeichenmenge; S: string; StartIdx: integer = 0): integer;
begin
  if (StartIdx < 1) or (StartIdx > length(S)) then
    Result := length(S)
  else
    Result := StartIdx;

  while Result > 0 do
  begin
    if S[Result] in Zeichenmenge then
      break
    else
      dec(Result);
  end;
end;

function PosLeft(Zeichenmenge: string; S: string; StartIdx: integer = 0): integer;
var
  i: integer;
  Menge: TZeichenMenge;
begin
  Menge := [];
  for i := 1 to length(Zeichenmenge) do
    Menge := Menge + [Zeichenmenge[i]];

  Result := PosLeft(Menge, S, StartIdx);
end;

function PosLeft(Zeichenmenge: TZeichenmenge; S: string; StartIdx: integer = 0): integer;
begin
  if (StartIdx < 1) or (StartIdx > length(S)) then
    Result := 1
  else
    Result := StartIdx;

  while Result <= length(S) do
  begin
    if S[Result] in Zeichenmenge then
      break
    else
      inc(Result);
  end;
  if Result > length(S) then
    Result := 0;
end;

function CountEqualChars(Str1, Str2: string; CharSensitive: boolean = false): integer;
var
  i: integer;
  Anz: integer;
begin
  Result := 0;
  if not CharSensitive then
  begin
    UniqueString(Str1);
    AnsiStrUpper(PChar(Str1));
    UniqueString(Str2);
    AnsiStrUpper(PChar(Str2));
  end;

  Anz := Min(Length(Str1), Length(Str2));
  for i := 1 to Anz do
  begin
    if Str1[i] = Str2[i] then
      inc(Result)
    else
      break;
  end;
end;

function Exchange(const str: string; SubStrPos, SubStrCount: integer;
  const NewSubStr: string): string;
begin
  Result := Left(str, SubStrPos - 1) + NewSubStr
    + Right(str, length(str) - SubStrPos - SubStrCount + 1);
end;

function InsertString(const str, SubStr: string; Position: integer): string;
begin
  CheckMinMax(Position, 1, length(str)+1);
  Result := Left(str, Position-1) + SubStr + Right(str, length(str)-Position+1);
end;

function DeleteXMLTag(xml, TagName: string): string;
var
  wo, len: integer;
begin
  xml := Trim(xml);
  len := length(TagName);
  wo := Pos('>', xml);
  if (wo > 0) and (wo < length(xml)) and (Left(xml, len+1) = '<' + TagName)
    and (Right(xml, len + 3) = '</' + TagName + '>') then
  begin
    Result := Copy(xml, wo + 1, length(xml) - wo - len - 3);
  end
  else
  begin
    Result := xml;
  end;
end;

function GetHomoString(FillChar: char; Count: integer): string;
var
  i: integer;
begin
  if Count < 0 then
    Count := 0;
  SetLength(Result, Count);
  for i := 1 to Count do
    Result[i] := FillChar;
end;

function BigInt(Zahl: extended): integer;
begin
  Result := trunc(Zahl);
  if Result <> Zahl then
  begin
    if Zahl > 0 then
      inc(Result)
    else
      dec(Result);
  end;
end;

function HigherInt(Zahl: extended): integer;
begin
  Result := trunc(Zahl);
  if Result <> Zahl then
  begin
    if Zahl > 0 then
      inc(Result);
  end;
end;

function LowerInt(Zahl: extended): integer;
begin
  Result := trunc(Zahl);
  if Result <> Zahl then
  begin
    if Zahl < 0 then
      dec(Result);
  end;
end;

function RoundInt(Zahl, Grenze: extended): integer;
begin
  if Grenze <= 0 then
    Result := HigherInt(Zahl)
  else if Grenze >= 1 then
    Result := LowerInt(Zahl)
  else
    Result := LowerInt(Zahl - Grenze) + 1;
end;

function Rest(Zahl: extended): extended;
begin
  Result := Zahl - trunc(Zahl);
end;

function BigDiv(Zahl1, Zahl2: integer): integer;
begin
  Result := Zahl1 div Zahl2;
  if Zahl1 mod Zahl2 > 0 then
    inc(Result);
end;


function FloatToNormStr(Zahl: extended; Nachkommastellen: integer): string;
var
  test: string;
  KommaChar: char;
begin
  if Nachkommastellen < 0 then
    Result := FloatToStr(Zahl)
  else
    Result := Format('%.*f', [Nachkommastellen, Zahl]);

  Test := FloatToStr(1.5);
  KommaChar := Test[2];
  if KommaChar <> '.' then
    Result := StringReplace(Result, KommaChar, '.', [rfReplaceAll]);
end;

function NormStrToFloat(Str: string): extended;
var
  test: string;
  KommaChar: char;
begin
  Test := FloatToStr(1.5);
  KommaChar := Test[2];
  if KommaChar <> '.' then
    Str := StringReplace(Str, '.', KommaChar, [rfReplaceAll]);

  Result := StrToFloat(Str);
end;

function NormStrToFloat(Str: string; Default: extended): extended;
begin
  try
    Result := NormStrToFloat(Str);
  except
    Result := Default;
  end;
end;

function StrToFloatDef(Str: string; Default: extended): extended;
begin
  try
    Result := StrToFloat(Str);
  except
    Result := Default;
  end;
end;

// InputToNormStrTry versucht den Inhalt von InputStr in ein Format zu bekommen, dass an die Funktion NormStrToFloat bergeben werden kann
// Falls dies definitiv nicht gelingt, dann wird '' zurckgegeben
// Auch wenn die Rckgabe nicht '' ist, ist noch nicht sichergestellt, dass die Rckgabe ein korrektes Format hat.
// Dies muss erst noch mit dem Aufruf der Funktion NormStrToFloat sichergestellt werden (siehe Code von InputToNormStr);
// InputToNormStrTry sorgt nur dafr, dass das Dezimalzeichen ein Punkt ist und entfernt
// evtl. vorhandene Tausender-Trennzeichen. z.B.  "1.000.000,5" wird zu "1000000.5" und "1,000,000.5" wird zu auch zu "1000000.5"
// Nur Punkt und Komma werden als Dezimal-, bzw. Tausender-Trennzeichen erkannt.
// Ob in InputStr sonstige Sonderzeichen enthalten sind interessiert InputToNormStrTry nicht.
// Diese werden einfach wieder zurckgegeben. Deshalb muss noch mit der Funktion NormStrToFloat sichergestellt werden,
// dass die Rckgabe einem "NormStr" entspricht, aber das macht ja bereits die Funktion InputToNormStr.
function InputToNormStrTry(InputStr: string): string;
  //CheckTausender prft, ob in Str nach jedem cTaus-Zeichen eine dreistellige Zahl steht und entfernt alle cTaus-Zeichen; Bei Fehler wird '' zurckgegeben
  function CheckTausender(Str: string; cTaus: char): string;
  var
    Fehler: boolean;
    Anz: integer;
    i: integer;
  begin
    // Nach jedem Tausender-Zeichen muss eine dreistellige Zahl kommen
    Fehler := false;
    i := 1;
    Anz := ListLen(Str, cTaus);
    while not Fehler and (i < Anz) do
    begin
      str := ListGetAt(InputStr, i, cTaus);
      Fehler := length(str) <> 3;
      if not Fehler then
        Fehler := StrToIntDef(str, -1) = -1;

      inc(i);
    end;

    if Fehler then
      Result := ''
    else
    begin // Wenn nach jedem Tausender-Zeichen eine dreistellige Zahl steht
      // Dann entfernen wir die ganzen Tausender-Zeichen
      Result := StringReplace(InputStr, cTaus, '', [rfReplaceAll]);
    end;
  end;

var
  NachKomma, VorKomma, str: string;
  AnzP, AnzK: integer;
  RightP, RightK: integer;
begin
  // Im Folgendem werden etliche List-Funktionen verwendet.
  // Diese werden nur verwendet, da sich damit Strings einfach
  // zerlegen und wieder zusammensetzen lassen, bzw. es einfach machen
  // die Anzahl von bestimmten Zeichen (.,) zu bestimmen
  AnzP := ListLen(InputStr, '.') - 1;
  AnzK := ListLen(InputStr, ',') - 1;
  if (AnzP > 1) or (AnzK > 1) or ((AnzP = 1) and (AnzK = 1)) then
  begin // Wenn scheinbar Tausender-Trennzeichen eingegeben wurden
    RightP := PosRight('.', InputStr);
    RightK := PosRight(',', InputStr);
    if RightP < RightK then
    begin // Wenn das Komma das Dezimalzeichen ist
      if AnzK > 1 then
        InputStr := ''
      else
      begin // Wenn es max. ein Komma gibt
        // Dann entfernen wir die Tausender-Trennzeichen
        VorKomma := ListGetAt(InputStr, 0, ',');
        str := CheckTausender(VorKomma, '.');
        if str = '' then
          InputStr := ''
        else if AnzK = 0 then
          InputStr := str
        else
        begin
          NachKomma := ListGetAt(InputStr, 1, ',');
          InputStr := str + '.' + NachKomma;
        end;
      end;
    end
    else
    begin // Wenn der Punkt das Dezimalzeichen ist
      if AnzP > 1 then
        InputStr := ''
      else
      begin // Wenn es max. einen Punkt gibt
        // Dann entfernen wir die Tausender-Trennzeichen
        VorKomma := ListGetAt(InputStr, 0, '.');
        str := CheckTausender(VorKomma, ',');
        if str = '' then
          InputStr := ''
        else
          InputStr := ListSetAt(InputStr, str, 0, '.');
      end;
    end;
  end
  else if AnzK = 1 then
  begin // Wenn das Dezimalzeichen ein Komma ist
    // Dann machen wir einen Punkt daraus
    InputStr := StringReplace(InputStr, ',', '.', []);
  end;

  Result := InputStr;
end;

function InputToNormStr(InputStr, Default: string): string;
var
  Zahl: extended;
begin
   Result := Default;

  InputStr := InputToNormStrTry(InputStr);
  if InputStr <> '' then
  begin // Wenn bis jetzt im InputStr noch kein Formatfehler endeckt wurde
    Zahl := NormStrToFloat(InputStr, -999);
    if Zahl <> -999 then
      Result := InputStr
    else if NormStrToFloat(InputStr, 0) <> 0 then
      Result := InputStr;
  end;
end;

function InputToFloat(InputStr: string; Default: extended): extended;
begin
    InputStr := InputToNormStrTry(InputStr);

    Result := NormStrToFloat(InputStr, Default);
end;

function CreatePolyRgn(Poly: TPolygon): HRGN;
var
  Anz: integer;
begin
  Result := 0;
  Anz := Length(Poly);
  if Anz > 0 then
    Result := CreatePolygonRgn(Poly[0], Anz, ALTERNATE);
end;

function GetPolygonRect(Poly: TPolygon): TRect;
var
  i: integer;
  MinX, MaxX: integer;
  MinY, MaxY: integer;
  Point: TPoint;
begin
  if Length(Poly) = 0 then
    Result := Rect(0, 0, 0, 0)
  else
  begin
    MinX := Poly[0].X;
    MinY := Poly[0].Y;
    MaxX := MinX;
    MaxY := MinY;
    for i := 1 to Length(Poly) - 1 do
    begin
      Point := Poly[i];
      if MinX > Point.X then
        MinX := Point.X
      else if MaxX < Point.X then
        MaxX := Point.X;

      if MinY > Point.Y then
        MinY := Point.Y
      else if MaxY < Point.Y then
        MaxY := Point.Y;
    end;

    Result := Rect(MinX, MinY, MaxX, MaxY);
  end;
end;

function GetPolygonRect(Poly: TExtPolygon): TExtRect;
var
  i: integer;
  MinX, MaxX: extended;
  MinY, MaxY: extended;
  Point: TExtPoint;
begin
  if Length(Poly) = 0 then
    Result := ExtRect(0, 0, 0, 0)
  else
  begin
    MinX := Poly[0].X;
    MaxX := Poly[0].Y;
    MinY := MinX;
    MaxY := MinY;
    for i := 1 to Length(Poly) - 1 do
    begin
      Point := Poly[i];
      if MinX > Point.X then
        MinX := Point.X
      else if MaxX < Point.X then
        MaxX := Point.X;

      if MinY > Point.Y then
        MinY := Point.Y
      else if MaxY < Point.Y then
        MaxY := Point.Y;
    end;

    Result := ExtRect(MinX, MinY, MaxX, MaxY);
  end;
end;

function MovePolygon(Poly: TExtPolygon; OffX, OffY: extended): TExtPolygon;
var
  i: integer;
begin
  SetLength(Result, Length(Poly));
  for i := 0 to Length(Poly) - 1 do
  begin
  	Result[i].X := Poly[i].X + OffX;
  	Result[i].Y := Poly[i].Y + OffY;
  end;
end;

function ComponentByName(Owner: TComponent; ComponentName: string): TComponent;
var
  i: integer;
begin
  Result := nil;
  for i := 0 to Owner.ComponentCount - 1 do
  begin
    if CompareText(Owner.Components[i].Name, ComponentName) = 0 then
    begin
      Result := Owner.Components[i];
      break;
    end;
  end;
end;

function ProcessMessages(MsgID: UINT): boolean;
var
  Msg: TMsg;
begin
  Result := False;
  while PeekMessage(Msg, 0, MsgID, MsgID, PM_REMOVE) do
  begin
    Result := True;

    TranslateMessage(Msg);
    DispatchMessage(Msg);
  end;
end;

function GetFileDate(FileName: string; out FileDateTime: TDateTime; CreationTime: boolean): boolean;
var
  sr: TSearchRec;
  LocalFileTime: TFileTime;
begin
  Result := false;
  if FindFirst(FileName, faAnyFile, sr) = 0 then
  try
    Result := true;
    if CreationTime then
    begin
      FileTimeToLocalFileTime(sr.FindData.ftCreationTime, LocalFileTime);
      FileTimeToDosDateTime(LocalFileTime, LongRec(sr.Time).Hi,
        LongRec(sr.Time).Lo);
    end;

    FileDateTime := FileDateToDateTime(sr.Time);
  finally
    FindClose(sr);
  end;
end;

procedure GetSubFolders(Path: string; SubPaths: TStrings);
var
  sr: TSearchRec;
  Search, NewPath: string;
begin
	if (Path <> '') and (Path[length(Path)] <> '\') then
  	Path := Path + '\';

  if DirectoryExists(Path) then
  begin
  	Search := Path + '*';
    if FindFirst(Search, faDirectory, sr) = 0 then
    begin
    	repeat
      	if (sr.Name <> '.') and (sr.Name <> '..') then
        begin
          NewPath := Path + sr.Name + '\';
          if DirectoryExists(NewPath) then
            SubPaths.Add(NewPath);
        end;
      until FindNext(sr) <> 0;
      FindClose(sr);
    end
  end;
end;

procedure GetFiles(Filter: string; Files: TStrings);
var
  sr: TSearchRec;
begin
  if FindFirst(Filter, faAnyFile, sr) = 0 then
  begin
    repeat
      Files.Add(sr.Name);
    until FindNext(sr) <> 0;
    FindClose(sr);
  end;
end;

function IsFileReadOnly(FileName: string): boolean;
var
  sr: TSearchRec;
begin
  while not DirectoryExists(FileName) and not FileExists(FileName) and (ListLen(FileName, '/\') > 1) do
    FileName := ListDeleteAt(FileName, ListLen(FileName, '/\') - 1, '/\');

  if (FileName <> '') and (FileName[length(FileName)] = ':') then
    FileName := FileName + '\';

  if DirectoryExists(FileName) or FileExists(FileName) then
  begin
    if FindFirst(FileName, faAnyFile, sr) = 0 then
     begin
      Result := (sr.Attr and faReadOnly) <> 0;
      FindClose(sr);
    end
    else
      raise Exception.Create('File not found');
  end
  else
    raise Exception.Create('File not found');
end;

procedure InitCanvas(Canvas: TCanvas);
begin
  Canvas.Pen.Mode := pmCopy;
  Canvas.Pen.Style := psSolid;
  Canvas.Pen.Width := 0;
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Color := clWhite;
  Canvas.Font.Name := 'Arial';
  Canvas.Font.Color := clBlack;
  Canvas.Font.Size := 10;
  Canvas.Font.Style := []; 
  Canvas.Font.Pitch := fpDefault;
end;


function GetPrinterPaperHeightInPixel: integer;
begin
  Result := GetDeviceCaps(Printer.Handle, PHYSICALHEIGHT);
end;

function GetPrinterPaperWidthInPixel: integer;
begin
  Result := GetDeviceCaps(Printer.Handle, PHYSICALWIDTH);
end;

function GetPrinterPaperHeightInMm: extended;
begin
  Result := GetPrinterPaperHeightInPixel / GetPrinterVertPixelPerMm;
end;

function GetPrinterPaperWidthInMm: extended;
begin
  Result := GetPrinterPaperWidthInPixel / GetPrinterHorzPixelPerMm;
end;

function GetPrintableHeightInPixel: integer;
begin
  Result := GetDeviceCaps(Printer.Handle, VERTRES);
end;

function GetPrintableWidthInPixel: integer;
begin
  Result := GetDeviceCaps(Printer.Handle, HORZRES);
end;

function GetPrintableHeightInMm: extended;
begin
  Result := GetPrintableHeightInPixel / GetPrinterVertPixelPerMm;
end;

function GetPrintableWidthInMm: extended;
begin
  Result := GetPrintableWidthInPixel / GetPrinterHorzPixelPerMm;
end;

function GetPrinterVertPixelPerInch: integer;
begin
  Result := GetDeviceCaps(Printer.Handle, LOGPIXELSY);
end;

function GetPrinterHorzPixelPerInch: integer;
begin
  Result := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
end;

function GetPrinterVertPixelPerMm: extended;
begin
  Result := GetPrinterVertPixelPerInch / 25.4;
end;

function GetPrinterHorzPixelPerMm: extended;
begin
  Result := GetPrinterHorzPixelPerInch / 25.4;
end;

function GetPrintableLeftBorderInPixel: integer;
begin
  Result := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETX);
end;

function GetPrintableTopBorderInPixel: integer;
begin
  Result := GetDeviceCaps(Printer.Handle, PHYSICALOFFSETY);
end;

function GetPrintableLeftBorderInMm: extended;
begin
  Result := GetPrintableLeftBorderInPixel / GetPrinterHorzPixelPerMm;
end;

function GetPrintableTopBorderInMm: extended;
begin
  Result := GetPrintableTopBorderInPixel / GetPrinterVertPixelPerMm;
end;

function GetPrintableRect: TExtRect;
begin
  Result := ExtBounds(GetPrintableLeftBorderInMm, GetPrintableTopBorderInMm,
    GetPrintableWidthInMm, GetPrintableHeightInMm);
end;

function GetPrintableRectInPixel: TRect;
var
  Left, Top: integer;
begin
  Left := GetPrintableLeftBorderInPixel;
  Top := GetPrintableTopBorderInPixel;
  Result := Rect(Left, Top,
    Left+GetPrintableWidthInPixel, Top+GetPrintableHeightInPixel);
end;


function IsItADisplayHandle(Handle: THandle): boolean;
begin
  Result := GetDeviceCaps(Handle, TECHNOLOGY) = DT_RASDISPLAY;
end;

procedure DrawTGraphic(Canvas: TCanvas; Graphic: TGraphic; ARect: TRect);
var
  Info: PBitmapInfo;
  Image: Pointer;
  Bitmap: TBitmap;
  InfoSize: DWORD;
  ImageSize: DWORD;
begin
  if not Graphic.Empty then
  begin
    if (Graphic is TBitmap) and not IsItADisplayHandle(Canvas.Handle) then
    begin // Bitmaps bekommen eine Sonderbehandlung, wenn nicht ganz normal auf dem Bildschirm ausgegeben wird
      Bitmap := TBitmap(Graphic);
      GetDIBSizes(Bitmap.Handle, InfoSize, ImageSize);
      Info := AllocMem(InfoSize);
      try
        Image := AllocMem(ImageSize);
        try
          GetDIB(Bitmap.Handle, Bitmap.Palette, Info^, Image^);
          with Info^.bmiHeader, ARect do
            StretchDIBits(Canvas.Handle, Left, Top, Right - Left,
              Bottom - Top, 0, 0, biWidth, biHeight, Image, Info^,
              DIB_RGB_COLORS, SRCCOPY);
        finally
          FreeMem(Image, ImageSize);
        end;
      finally
        FreeMem(Info, InfoSize);
      end;
    end
    else
    begin
      TProtectedGraphic(Graphic).Draw(Canvas, ARect);
    end;
  end;
end;

function IsIntf(Instance: TObject; Intf: TGUID): boolean;
var
	Dummy: IUnknown;
begin
  Result := Supports(Instance, Intf, Dummy);
end;

function IsIntf(const Instance: IUnknown; Intf: TGUID): boolean;
var
	Dummy: IUnknown;
begin
  Result := Supports(Instance, Intf, Dummy);
end;

function GetKeyboardShiftState: TShiftState;
var
  KeyState: TKeyboardState;
begin
  GetKeyboardState(KeyState);
  Result := KeyboardStateToShiftState(KeyState);
end;


end.
